(defun c:fillet1()
  (setq dcl_id (load_dialog "fillet1.dcl"))
	(if (< dcl_id 0) (exit))
	(init_variables)
  (while (> what 2)
    (if (not (new_dialog "fillet1" dcl_id)) (exit))
		(init_tiles)
		(get_actions)
	)
  (unload_dialog dcl_id)
);defun

;********************************************************************
;                        INIT_VARIABLES
;********************************************************************
(defun init_variables()
(setq what 3)
(setq   filletrad   (getvar "filletrad")
        rad         (rtos filletrad)
        trimmode    (getvar "trimmode")
        l           "1"
        pl          "0"
        rad0        "0"
        tip         "l"
);setq
(cond
  ((= trimmode 0) (setq mode "nt" t "0" nt "1"))
  ((= trimmode 1) (setq mode "t"  t "1" nt "0"))
);cond
);defun

;********************************************************************
;                           INIT_TILES
;********************************************************************
(defun init_tiles()
(set_tile "rad"     rad)
(set_tile "t"       t)
(set_tile "nt"      nt)
(set_tile "l"       l)
(set_tile "pl"      pl)
(set_tile "rad0"    rad0)
);defun

;********************************************************************
;                           GET_ACTIONS
;********************************************************************
(defun  get_actions()
(action_tile "rad"    "(setq rad $value)    (rad_do)")
(action_tile "rad0"   "(rad0_do)")
(action_tile "mode"   "(setq mode $value)   (mode_do)")
(action_tile "tip"    "(setq tip  $value)   (tip_do)")
(action_tile "go"     "(done_dialog 3)")
(action_tile "undo"   "(done_dialog 4)")

(setq what (start_dialog))
(if (= what 3) (start_do))
(if (= what 4) (undo_do))
);defun

;********************************************************************
;                              RAD_DO
;********************************************************************
(defun rad_do()
(setvar "filletrad"  (distof rad))
(setq rad (rtos (getvar "filletrad")))
(set_tile "rad" rad)
);defun

;********************************************************************
;                             RAD0_DO
;********************************************************************
(defun rad0_do()
(setq rad "0")
(rad_do)
(set_tile "rad0" rad0)
);defun

;********************************************************************
;                             MODE_DO
;********************************************************************
(defun mode_do()
(cond
((= mode "t") (setq trimmode 1 t "1" nt "0"))
((= mode "nt")(setq trimmode 0 t "0" nt "1"))
);cond
(setvar "trimmode" trimmode)
);defun

;********************************************************************
;                             TIP_DO
;********************************************************************
(defun tip_do()
(cond
((= tip "l") (setq l "1" pl "0"))
((= tip "pl")(setq l "0" pl "1"))
);cond
);defun

;********************************************************************
;                             START_DO
;********************************************************************
(defun start_do()
(cond
((= tip "l")  (command "fillet" pause pause))
((= tip "pl") (command "fillet" "p" pause pause))
);cond
(command "delay" "50")
);defun

;********************************************************************
;                             UNDO_DO
;********************************************************************
(defun undo_do()
(command "u")
);defun

