;;;--------------------------------------------------------------------;;;
;;;           "", ""  ..         ;;;
;;;                   Slit15EN.lsp Version 2.0                         ;;;
;;;                  AutoCAD R14 for Windows                        ;;;
;;;                           31.01.00                                 ;;;
;;;                   :                          ;;;
;;;                           ;;;
;;;         "-  "           ;;;
;;;                 .     .59-16-23                     ;;;
;;;             E-Mail:  tb5@ugm.zsmk.nvkz.kuzbass.net                 ;;;
;;;--------------------------------------------------------------------;;;

;;
;; 2.0  AutoCAD 2000 (15)
;;     :
;;	1.       : Arrow
;;	2.    " ": ViewAr
;;	3.   "": Slit
;;  4.     " ": ViewDis 
;;  5.      "-": SlitDis 
;;


;=============================================================
;;;  

;         
(defun UnBlock (pt ss / blkDat bn count Obj Objd Onjn blkName insDat insName)
    ; pt -   
    ; ss -  ,      
    ;            SSGET  SSADD
    
    (setq blkDat (list (cons 0 "BLOCK") (cons 2 "*Unnn") (cons 10 pt) (cons 70 1)) )
    (setq bn (entmake blkDat))
    
    (setq count (- (sslength ss) 1))
    (while (>= count 0)
        (setq Obj (ssname ss count))
        (setq Objd (entget Obj))
        (entdel Obj)
        (setq Onjn (entmake Objd))
        (setq count (- count 1))
    )
    (setq blkName (entmake '((0 . "ENDBLK")) ))
    (setq insDat (list (cons 0 "INSERT") (cons 2 blkName) (cons 10 pt) (cons 70 1)) )
    (setq insName (entmake insDat))
)

;    
(defun SetOpt ()
; 
	(setq sblip (getvar "BLIPMODE"))
	(setq scmde (getvar "CMDECHO"))
	(setvar "BLIPMODE" 0)
	(setvar "CMDECHO" 0)
)

(defun RetOpt ()
; 
	(setvar "BLIPMODE" sblip)
	(setvar "CMDECHO" scmde)
)

(defun SaveLYype ()
;  
	(setq oldColor (getvar "CECOLOR"))	    ;  
	(setq oldLType (getvar "CELTYPE"))	    ;   
	;(setq oldWeight (getvar "CELWEIGHT"))	;  
)

(defun RetLType ()
;   
	(setvar "CECOLOR" oldColor)
	(setvar "CELTYPE" oldLType)
	;(setvar "CELWEIGHT" oldWeight)
)

;  OSNAP
(defun Osnap_Off  ()
	(setq sosnapm (getvar "OSMODE"))
	(setvar "OSMODE" 0)
)

;  OSNAP
(defun Osnap_On  ()
	(setvar "OSMODE" sosnapm)
)

;-------------------------------------------------------------

;     
(defun dtr (Ang)
	(/ (* Ang pi) 180)
)

;     
(defun rtd (Ang) 
	 (* Ang (/  180 pi))
)

;  
(defun tan (Ang)
	(setq tangens (/ (sin Ang) (cos Ang)))
	T tangens
)

;-------------------------------------------------------------

;  
(defun getSymL (Sym th scale / cth pt1 SymL TxtPoints)
    ; Sym       - 1   string
    ; cth       -     
    ; scale     - 
    ; SymL      -  
    ; TxtPoints -     
    
    (if (= Sym " ")
        (setq SymL (* th 0.8 scale) )
        (progn
            (setq cth (* th scale))
            (setq TxtPoints (textbox (list (cons 1 Sym) (cons 40 cth))) )
            (setq pt1 (cadr TxtPoints) )
            (setq SymL (car pt1))
        )
    )
    t SymL
)

;;;   
;=============================================================


;;; 
;=============================================================
;      
(defun drwArrow (sp	ep scale 
                 / ArAng ArL ArW ArWD ArCOL ArWD)
;sp -   
;ep -  
;scale -  
	(setq ArAng (angle sp ep))	; 
	(setq ArL 5.0)	; 
	(setq ArW 1.8)	; 
	(setq ArCOL (getvar "DIMCLRD"))	; , - 
									;  
	(setq ArWD (getvar "DIMLWD"))	;  , - 
									;  
	
	(if (= (getvar "TILEMODE") 0)   ;   
		(setq scale 1)
	)
	;  
	(SaveLYype)	
	(setvar "CECOLOR" (rtos ArCOL 2 0))
	(setvar "CELTYPE" "CONTINUOUS")
	;(setvar "CELWEIGHT" ArWD)
	
	(setq pt1 (polar ep (- ArAng (dtr 180)) (* ArL scale)))
	(setq pt2 (polar pt1 (+ ArAng (dtr 90)) (* (/ ArW 2.0) scale)))
	(setq pt1 (polar pt1 (- ArAng (dtr 90)) (* (/ ArW 2.0) scale)))
	
	(setq S2 nil)
	(setq S2 (ssadd))
	(Osnap_Off)
	(command "_Line" sp ep "")
	(ssadd (entlast) S2)
	(command "_Solid" pt1 pt2 ep ep "")
	(ssadd (entlast) S2)
	(Osnap_On)
	
	;  
	(RetLType)
	T S2	;     
)

;       
;  ,   
(defun drwTxtHorUpArr (TxtUpAr sp ep ptTxt Scale
                       / ArAng ArWD
                         pt2 
                         CurTxtStyle th TxtCOL TxtH)
	;TxtUpAr - 
	;sp -   
	;ep -   
	;ptTxt -      

	;!!!
	;      
	;      0.0,   
	;      1.4    
	;  (   ),  
	;        
	;     

	(setq ArAng (angle sp ep))	; 
	(setq TxtCOL (getvar "DIMCLRD"))	; , - 
										;  
	(setq TxtH (* 1.4 (getvar "DIMTXT") Scale))	;  
											    ;   * 1.4
	(setq ArWD (getvar "DIMLWD"))	;  , - 
									;  
	
	(if (= (getvar "TILEMODE") 0)   ;   
		(setq scale 1)
	)

	;  
	(SaveLYype)						
	(SETVAR "CECOLOR" (RTOS TXTCOL 2 0))
	(setvar "CELTYPE" "CONTINUOUS")
	;(setvar "CELWEIGHT" ArWD)
	(setq CurTxtStyle (getvar "TEXTSTYLE"))
	(setq th (cdr (assoc 40 (tblsearch "style" CurTxtStyle))))
	
	(Osnap_Off)
	(if (and (>= ArAng 0.0) (> (dtr 90) ArAng))
		(progn
			(setq pt2 (polar ptTxt (+ ArAng (dtr 90)) (* Scale 1.0)))
			(if (= th 0.0)
				(command "_text" "_Justify" "_Right" pt2 TxtH 0.0 TxtUpAr)
				(command "_text" "_Justify" "_Right" pt2 0.0 TxtUpAr)
			)
		)
	)
	(if (= ArAng (dtr 90))
		(progn
			(setq pt2 (polar ptTxt 0.0 (* Scale 1.0)))
			(if (= th 0.0)
				(command "_text" "_Justify" "_TL" pt2 TxtH 0.0 TxtUpAr)
				(command "_text" "_Justify" "_TL" pt2 0.0 TxtUpAr)
			)
		)
	)
	(if (and (> ArAng (dtr 90)) (>= (dtr 180) ArAng))
		(progn
			(setq pt2 (polar ptTxt (+ ArAng (dtr 90)) (* Scale 1.0)))
			(if (= th 0.0)
				(command "_text" "_Justify" "_BL" pt2 TxtH 0.0 TxtUpAr)
				(command "_text" "_Justify" "_BL" pt2 0.0 TxtUpAr)
			)
		)
	)
	(if (and (> ArAng (dtr 180)) (> (dtr 270) ArAng))
		(progn
			(setq pt2 (polar ptTxt (- ArAng (dtr 90)) (* Scale 1.0)))
			(if (= th 0.0)
				(command "_text" "_Justify" "_Right" pt2 TxtH 0.0 TxtUpAr)
				(command "_text" "_Justify" "_Right" pt2 0.0 TxtUpAr)
			)
		)
	)
	(if (= ArAng (dtr 270))
		(progn
			(setq pt2 (polar ptTxt (- ArAng (dtr 90)) (* Scale 1.0)))
			(if (= th 0.0)
				(command "_text" "_Justify" "_Right" pt2 TxtH 0.0 TxtUpAr)
				(command "_text" "_Justify" "_Right" pt2 0.0 TxtUpAr)
			)
		)
	)

	(if (and (> ArAng (dtr 270)) (> (dtr 360) ArAng))
		(progn
			(setq pt2 (polar ptTxt (+ ArAng (dtr 90)) (* Scale 1.0)))
			(if (= th 0.0)
				(command "_text" pt2 "_Justify" "_BL" TxtH 0.0 TxtUpAr)
				(command "_text" pt2 "_Justify" "_BL" 0.0 TxtUpAr)
			)
		)
	)
	(Osnap_On)

	;  
	(RetLType)

)

;   
; 
(defun drwSlitEndLin (sp ep scale
                      / pt1 pt2 pt3 pt4
                        LinAng LinCOL LinL LinW
                        ArWD)
	;sp -   
	;ep -  
	;scale -  

	;
	;           sp
	;  pt2     /         pt4          ep
	;   +*****/*********+            /
	;   *****+***********           +
	;   +***************+
	;  pt1               pt3
	;

	(setq LinAng (angle sp ep))				; 
	(setq LinCOL (getvar "DIMCLRD"))		; , - 
											;  
	(setq LinL 10.0)						; 
	(setq LinW 0.9)							; 
	(setq ArWD (getvar "DIMLWD"))	; , - 
									;  

	(if (= (getvar "TILEMODE") 0)   ;   
		(setq scale 1)
	)

	;  
	(SaveLYype)						
	(SETVAR "CECOLOR" (RTOS LINCOL 2 0))
	(setvar "CELTYPE" "CONTINUOUS")
	;(setvar "CELWEIGHT" ArWD)
	
	; 
	(setq pt1 (polar sp (- LinAng (dtr 180)) (* scale 0.3 LinL)))
	(setq pt1 (polar pt1 (- LinAng (dtr 90)) (* scale 0.5 LinW)))
	(setq pt2 (polar pt1 (+ LinAng (dtr 90)) (* scale LinW)))
	(setq pt3 (polar pt1 LinAng (* scale LinL)))
	(setq pt4 (polar pt2 LinAng (* scale LinL)))
	;  
	
	;
	(Osnap_Off)
	(command "_Solid" pt1 pt2 pt3 pt4 "")
	(ssadd (entlast) SelObj)	
	(Osnap_On)
	; 
	
	;  
	(RetLType)
)

;    
(defun drwSlitMidLin (sp mp ep scale
                      / pt1 pt2 pt3 pt4 pt5 pt6
                        LinAngS LinAngE LinCOL LinL
                        ArWD)
	;sp -   
	;mp -   
	;ep -  
	;scale -  

	;
	;
	;		  sp	pt1		   pt3
	;		 /	     +********+
	;		+	     ********+*
	;			     +******+*\
	;			    pt2  pt4***\
	;			            *** mp
	;			            ***
	;			            ***
	;			            +*+
	;          		     pt6   pt5
	;            
	;						 +
	;						  \
	;						   ep
	;

	(setq LinAngS (angle mp sp))			;  
	(setq LinAngE (angle mp ep))			;  
	(setq LinCOL (getvar "DIMCLRD"))		; , - 
											;  
	(setq LinL 5.0)							;     
											;  
	(setq LinW 0.9)							; 
	(setq ArWD (getvar "DIMLWD"))	; , - 
									;  

	(if (= (getvar "TILEMODE") 0)   ;   
		(setq scale 1)
	)

	;  
	(SaveLYype)						
	(SETVAR "CECOLOR" (RTOS LINCOL 2 0))
	(setvar "CELTYPE" "CONTINUOUS")
	;(setvar "CELWEIGHT" ArWD)
	
	; 
	(setq pt1 (polar mp LinAngS (* scale LinL)))
	(setq pt1 (polar pt1 (- LinAngS (dtr 90)) (* scale 0.5 LinW)))
	(setq pt2 (polar pt1 (+ LinAngS (dtr 90)) (* scale LinW)))
	
	(setq pt5 (polar mp LinAngE (* scale LinL)))
	(setq pt5 (polar pt5 (+ LinAngE (dtr 90)) (* scale 0.5 LinW)))
	(setq pt6 (polar pt5 (- LinAngE (dtr 90)) (* scale LinW)))

	(setq pt3 (polar pt1 (- LinAngS (dtr 180)) (* scale (+ LinL (* 0.5 LinW (tan (/ (- (dtr 180) (- LinAngE LinAngS)) 2)))))))
	(setq pt4 (polar pt2 (- LinAngS (dtr 180)) (* scale (+ LinL (* 0.5 LinW (tan (/ (- (dtr 180) (- LinAngS LinAngE)) 2)))))))
	
	;  
	
	;
	(Osnap_Off)
	(command "_Solid" pt1 pt2 pt3 pt4 "")
	(ssadd (entlast) SelObj)	
	(command "_Solid" pt3 pt4 pt5 pt6 "")
	(ssadd (entlast) SelObj)
	(Osnap_On)
	; 
	
	;  
	(RetLType)
)

;    
(defun drwSlitArTxt (cp pp dAng SlitDis scale
                     / ep sp
                       ArAng ArL ArW ArCOL ArWD
                       pt1 pt2 ptTxt
                       Jut TxtH CurTxtStyle th)
	;cp -   
	;pp -   
	;ArAng -   (90  -90 )
	;SlitDis -  
	;scale -  

	;
	;					   cp
	;  pp				  /
	;  \	*************/****
	;	+	************+*****
	;		******************
	;					+---ep
	;				   ***
	;				   ***
	;				  * * *
	;				  * * *
	;		  			*
	;		 			*
	;					*     PtTxt
	;					*    /
	;					*	+
	;					*
	;					+**sp
	;
	
	(setq SlitAng (angle cp pp))			;  

	(if (= (getvar "TILEMODE") 0)   ;   
		(setq scale 1)
	)

	
	(setq ep (polar cp (+ SlitAng (dtr dAng)) (* 0.45 scale)))
	(setq sp (polar ep (+ SlitAng (dtr dAng)) (* 12.0 scale)))
	

	(setq ArAng (angle sp ep))			; 
	(setq ArL 5.0)						; 
	(setq ArW 1.8)						; 
	(setq ArCOL (getvar "DIMCLRD"))		; , - 
										;  
	(setq ArWD (getvar "DIMLWD"))	;  , - 
									;  


	;  
	(SaveLYype)						
	(setvar "CECOLOR" (rtos ArCOL 2 0))
	(setvar "CELTYPE" "CONTINUOUS")
	;(setvar "CELWEIGHT" ArWD)
		
	; 
	(setq pt1 (polar ep (- ArAng (dtr 180)) (* ArL scale)))
	(setq pt2 (polar pt1 (+ ArAng (dtr 90)) (* (/ ArW 2.0) scale)))
	(setq pt1 (polar pt1 (- ArAng (dtr 90)) (* (/ ArW 2.0) scale)))
	;  
	(setq PtTxt (polar sp ArAng (* scale 5.0)))
	(setq ptTxt (polar ptTxt (- SlitAng (dtr 180)) (* scale ArW)))
	
	;
	(Osnap_Off)
	
	(command "_Line" sp ep "")
	(ssadd (entlast) SelObj)
	(command "_Solid" pt1 pt2 ep ep "")
	(ssadd (entlast) SelObj)
	
	;
	(if (= 0.0 ArAng)
		(if (= SlitAng (dtr 90))
			(setq Jut "_TR")
			(setq Jut "_Right")
		)
	)

	(if (and (< 0.0 ArAng) (< ArAng (dtr 90)))
		(if (and (< (dtr 90) SlitAng) (< SlitAng (dtr 180)))
			(setq Jut "_TL")
			(setq Jut "_Right")
		)
	)

	(if (= (dtr 90) ArAng)
		(if (= SlitAng (dtr 180))
			(setq Jut "_TL")
			(setq Jut "_TR")
		)
	)

	(if (and (< (dtr 90) ArAng) (< ArAng (dtr 180)))
		(if (and (< (dtr 180) SlitAng) (< SlitAng (dtr 270)))
			(setq Jut "_BL")
			(setq Jut "_TR")
		)
	)

	(if (= (dtr 180) ArAng)
		(if (= SlitAng (dtr 270))
			(setq Jut "_BL")
			(setq Jut "_TL")
		)
	)

	(if (and (< (dtr 180) ArAng) (< ArAng (dtr 270)))
		(if (and (< (dtr 270) SlitAng) (< SlitAng (dtr 360)))
			(setq Jut "_Right")
			(setq Jut "_TL")
		)
	)

	(if (= (dtr 270) ArAng)
		(if (or (= SlitAng 0.0) (= SlitAng (dtr 360)))
			(setq Jut "_Right")
			(setq Jut "_BL")
		)
	)

	(if (and (< (dtr 270) ArAng) (< ArAng (dtr 360)))
		(if (and (< 0.0 SlitAng) (< SlitAng (dtr 90)))
			(setq Jut "_TR")
			(setq Jut "_BL")
		)
	)

	(setq TxtH (* 1.4 (getvar "DIMTXT") Scale))	;  
                                                        ;   * 1.4
	(setq CurTxtStyle (getvar "TEXTSTYLE"))
	(setq th (cdr (assoc 40 (tblsearch "style" CurTxtStyle))))
	(if (= th 0.0)
		(command "_text" "_Justify" Jut PtTxt TxtH 0.0 SlitDis)
		(command "_text" "_Justify" Jut PtTxt 0.0 SlitDis)
	)
	
	(Osnap_On)
	; 
	
	;  
	(RetLType)
)

;;;  
;=============================================================


;;;    
;=============================================================
;      
(defun C:Arrow ( / ArStart ArEnd 
                   SelObj blkName)
	;    
	;  DIMSCALE (  )
	;   - CONTINUOUS
	;   
	;  DIMCLRD (  )
	;    
	;  DIMLWD (  )

	;       

	(SetOpt)
	(initget 1)
	(setq ArStart (getpoint "\n  : "))
	(initget 1)
	(setq ArEnd (getpoint ArStart "\n  : "))
	(While (equal ArStart ArEnd)
		(prompt  "\n:      ")
		(initget 1)
		(setq ArEnd (getpoint ArStart "\n  : "))
	)

	(setq SelObj (drwArrow ArStart ArEnd (getvar "dimscale")))
	
	(UnBlock ArEnd SelObj)
	
    (prin1)
    (setq SelObj nil)
	(prin1)
	(RetOpt)
)

;  " X"
(defun C:ViewAr ( / Scale Vsp VAng Vep Vmp VTxt SelObj blkName)
	;    
	;  DIMSCALE
	;   - CONTINUOUS
	;   
	;  DIMCLRD (  )
	;    
	;  DIMLWD (  )

	;       


	;
	;
	;		  *
	;		 * *
	;		*   *
	;		*****
	;		*   *  **
	;                **
	;	*****************
	;                **
	;			   **
	;				
	
	;!!!
	;      
	;      0.0,   
	;      1.4    
	;  (   ),  
	;        
	;     

	(setq Scale (getvar "dimscale"))	;  
										;    

	(if (= (getvar "TILEMODE") 0)   ;   
		(setq scale 1)
	)

	(initget 1)
	(setq Vsp (getpoint "\n  : "))
	(initget 1)
	(setq VAng (getangle Vsp "\n : "))
	(setq Vep (polar Vsp Vang (* Scale 12.0)))
	(setq Vmp (polar Vsp VAng (* 6 Scale)))
	
	(setq SelObj (drwArrow Vsp Vep Scale))
	
	(UnBlock Vep SelObj)
	
	(setq SelObj nil)
	(setq VTxt nil)
	(While (or (null VTxt) (= VTxt ""))
		(setq VTxt (getstring "\n  <A>: "))
		(if (or (null VTxt) (= VTxt ""))
			(setq VTxt "")
		)
	)
	(drwTxtHorUpArr VTxt Vsp Vep Vmp Scale)
)

;  
(defun C:Slit ( / Sc SelObj StartPt MidPt SecondPt pppt ppt NextPt 
                  oldUCSICON ArPt CAng AAng dArAng CTxt blkName)
	;    
	;  DIMSCALE
	;   - CONTINUOUS
	;   
	;  DIMCLRD (  )
	;    
	;  DIMLWD (  )

    ;       
	
	;!!!
	;      
	;      0.0,   
	;      1.4    
	;  (   ),  
	;        
	;     

	(setq Sc (getvar "dimscale"))	;  
									;    

	(if (= (getvar "TILEMODE") 0)   ;   
		(setq scale 1)
	)

	(setq SelObj nil)
	(setq SelObj (ssadd))
	
	(initget 1)
	(setq StartPt (getpoint "\n  : "))
	(initget 1)
	(setq MidPt (getpoint StartPt "\n  : "))
	(drwSlitEndLin StartPt MidPt Sc)
	(setq SecondPt MidPt)
	(setq pppt StartPt)
	(setq ppt MidPt)
	(setq NextPt T)
	(while (/= NextPt nil) 
		(setq NextPt (getpoint ppt "\n  : "))
		(if (/= NextPt nil)
			(progn
				(drwSlitMidLin pppt ppt NextPt Sc)
				(setq pppt ppt)
				(setq ppt NextPt)
			)
			(progn
				(setq EndPt ppt)
				(drwSlitEndLin EndPt pppt Sc)
				
				(Osnap_Off)
				(setq oldUCSICON (getvar "UCSICON"))
				(setvar "UCSICON" 0)
				(command "_ucs" "_3point" EndPt pppt "")
				(setq oldOrthmode (getvar "ORTHOMODE"))
				(setvar "ORTHOMODE" 1)
				
				(SETQ old_error *error*) 
                (DEFUN *error* ( msg )
                    (if old_error (setq *error* old_error))
                    (if msg (princ "\n   " ))
                    ;   
				    (Osnap_On)
				    (setvar "ORTHOMODE" oldOrthmode)
				    (COMMAND "_ucs" "_P")
				    (setvar "UCSICON" oldUCSICON)
                    (GC)
                )

				(setq ArPt (getpoint (list 0.0 0.0) "    ? "))
				(setq CAng (angle (list 0.0 0.0) pppt))
				(setq AAng (angle (list 0.0 0.0) ArPt))

				(if (and (<= 0 CAng) (<= CAng (dtr 180)))
					(if (and (<= CAng AAng) (< AAng (+ CAng (dtr 180))))
						(setq dArAng 90)
						(setq dArAng (- 90))
					)
				)

				(if (and (< (dtr 180) CAng) (< CAng (dtr 360)))
					(if (and (< (- CAng (dtr 180)) AAng) (<= AAng CAng))
						(setq dArAng (- 90))
						(setq dArAng 90)
					)
				)
				(setq CTxt nil)
				(While (or (null CTxt) (= CTxt ""))
					(setq CTxt (getstring "\n  <A>: "))
					(if (or (null CTxt) (= CTxt ""))
						(setq CTxt "")
					)
				)
				(Osnap_On)
				(setvar "ORTHOMODE" oldOrthmode)
				(COMMAND "_ucs" "_P")
				(setvar "UCSICON" oldUCSICON)
				;   
				(drwSlitArTxt EndPt pppt dArAng CTxt Sc)
				(setq dArAng (* (- 1) dArAng))
				(drwSlitArTxt StartPt SecondPt dArAng CTxt Sc)
			)
		)
		
 	)

	;       EndPt
    (UnBlock EndPt SelObj)

	(setq SelObj nil)
	;    
)



;;;     
;=============================================================
(princ "\n     Slit_14.lsp ")
(princ "\n***                   ACAD TOOLS.  UTILITES                   ***")
(princ "\n***  , E-Mail: tb5@ugm.zsmk.nvkz.kuzbass.net ***")
