;----------------------------------------------------------------------------
;        ,  , , 
;   Blocks.lsp:      
;   Blocks.dcl
;----------------------------------------------------------------------------
(defun c:blocks ( / fSetBox fSelectBlk fToggle fGetData  fModifyBlk
             lBlocks lLayers bModify dcl oldv
             BlkName ReplName LayName ColNumber ScaleXYZ )
;---------------------------------------------------------------------------
(defun fSetBox ( key lst / val )
  (start_list key)
  (foreach val lst
    (add_list (cond ((= 'STR  (type val)) val)
                    ((= 'INT  (type val)) (itoa val))
                    ((= 'REAL (type val)) (rtos val))
                    (T (print "error") (exit))
  ) ))
  (end_list)
)
;---------------------------------------------------------------------------
(defun fSelectBlk ( val / ss )
  (setq BlkName (nth (atoi val) lBlocks))
  (setq ss (ssget "_X" (list '(0 . "INSERT") (cons 2 BlkName))))
  (set_tile "TypeCount"
    (strcat ":  " (itoa (if ss (sslength ss) 0)) "  ()"))
  (setq bModify (if ss T nil))
)
;---------------------------------------------------------------------------
(defun fToggle ( val key key_enable )
  (cond
    ((= val "0") (mode_tile key_enable 1) nil)
    ((not bModify) (set_tile key "0") (mode_tile key_enable 1) nil)
    (T (mode_tile key_enable 0) T)
  )
)
;---------------------------------------------------------------------------
(defun fGetData ()
  (setq ReplName  (if ReplName (nth (atoi (get_tile "ReplName")) lBlocks))
        LayName   (if LayName  (nth (atoi (get_tile "LayName"))  lLayers))
        ColNumber (if ColNumber (atoi (get_tile "ColNumber")))
        ScaleXYZ  (if ScaleXYZ  (atof (get_tile "ScaleXYZ")))
  )
  (done_dialog 1)
)
;---------------------------------------------------------------------------
(defun fModifyBlk ( name group value / i ss ent dxf new_dot old_dot )
  (setq i 0)
  (setq new_dot (cons group value))
  (if (setq ss (ssget "_X" (list '(0 . "INSERT") (cons 2 name))))
    (while (setq ent (ssname ss i))
       (setq i   (1+ i)
             dxf (entget ent)
             old_dot (assoc group dxf)
       )
       (entmod
         (if old_dot (subst new_dot old_dot dxf) (cons new_dot dxf))
       )
       (entupd ent)
  ) )
  i
)

;---------------------------------------------------------------------------
  (if (not ai_table) (load "ai_utils.lsp"))
 (setq  dcl     (load_dialog "Blocks.dcl")
        lBlocks (acad_strlsort (ai_table "BLOCK" 2))
        lLayers (acad_strlsort (ai_table "LAYER" 0))
  )
  (new_dialog "BlocksAdmin" dcl)
  (fSetBox "BlkName" lBlocks)
  (fSetBox "LayName" lLayers)
  (fSetBox "ReplName" lBlocks)
  (fSelectBlk "0")
  (set_tile "ColNumber" "256") (mode_tile "ColNumber" 1)
  (set_tile "ScaleXYZ"  "1.0") (mode_tile "ScaleXYZ" 1)
  (mode_tile "ReplName"  1)    (mode_tile "LayName" 1)
  (action_tile "BlkName" "(fSelectBlk $value)")
  (action_tile "FlgReplace" "(setq ReplName  (fToggle $value $key \"ReplName\"))")
  (action_tile "FlgMove"    "(setq LayName   (fToggle $value $key \"LayName\"))")
  (action_tile "FlgColor"   "(setq ColNumber (fToggle $value $key \"ColNumber\"))")
  (action_tile "FlgScale"   "(setq ScaleXYZ  (fToggle $value $key \"ScaleXYZ\"))")
  (action_tile "accept" "(fGetData)")

(if (= (start_dialog) 1) (progn
    (setq oldv (getvar "BLIPMODE"))
   (setvar "BLIPMODE" 0) 

    (if ScaleXYZ (progn
      (fModifyBlk BlkName 41 ScaleXYZ)
      (fModifyBlk BlkName 42 ScaleXYZ)
      (fModifyBlk BlkName 43 ScaleXYZ)
    ))
    (if LayName   (fModifyBlk BlkName 8 LayName))
    (if ColNumber (fModifyBlk BlkName 62 ColNumber))
    (if ReplName  (fModifyBlk BlkName 2 ReplName))  ;   !
(setvar "BLIPMODE" oldv)      
  ))
  (unload_dialog dcl)(prin1)
)
