(defun WORKING (/ WRK)
   (if (= WRKCNT nil) (setq WRKCNT 0))
   (setq
      WRKCNT (1+ WRKCNT)
   )
   (if (= WRKCNT 1) (setq WRK "-"))
   (if (= WRKCNT 2)
      (setq WRK "\\")
   )
   (if (= WRKCNT 3) (progn (setq WRK "/") (setq WRKCNT 0)))
   (princ
      (strcat "\n" WRK "\n")
   )
)
(defun RTD (A) (setq A (/ (* A 180) pi)))
(defun DTR (A)
   (setq A (* pi (/ A 180)))
)

;initialize dialog box definition
(defun INIT ()
   (setq DCL_ID (load_dialog "ddchtxt"))
   (if (not (new_dialog "ddchtxt" DCL_ID))
      (exit)
   )
   (action_tile "width"     "(witog $value)")          ;toggle
   (action_tile "height"    "(httog $value)")         ;   \/
   (action_tile "rotation"  "(rotog $value)")       ;   \/
   (action_tile "style"     "(sttog $value)")
   (action_tile "w_edit"    "(w_edit $value)") ;edit
   (action_tile "r_edit"    "(r_edit $value)")
   (action_tile "h_edit"    "(h_edit $value)") ;box
   (action_tile "s_edit"    "(s_edit $value)") ;actions
   (action_tile "hp_button" "(done_dialog 3)") ;height pick button action
   (action_tile "rp_button" "(done_dialog 4)") ;rotation pick button action
   (action_tile "ss_poppup" "(ss_pop_act $value)") ;style list popup action
   (action_tile "accept"    "(done_dialog 1)")
   (action_tile "cancel"    "(done_dialog 2)")
   (if NEWSTY
      (set_tile "s_edit" NEWSTY)
      (set_tile "s_edit" (setq NEWSTY (getvar "textstyle")))
   )
   (ST_LIST) ;initialize style popup list
   (if NEWWID
      (set_tile "w_edit" NEWWID)
      (set_tile "w_edit" (setq NEWWID "1.0000"))
   )
   (if NEWHEI
      (set_tile "h_edit" NEWHEI)
      (if NEWHEI2
         (set_tile "h_edit" (setq NEWHEI NEWHEI2))
         (set_tile "h_edit" (setq NEWHEI (rtos (getvar "textsize"))))
      )
   )
   (if NEWROT
      (set_tile "r_edit" NEWROT)
      (if NEWROT2
         (set_tile "r_edit" (setq NEWROT NEWROT2))
         (set_tile "r_edit" (setq NEWROT "0.0000"))
      )
   )
   (if (and RETURN HT_TOG)
      (progn
         (set_tile "height" "1")
         (mode_tile "h_edit" 0)
         (mode_tile "hp_button" 0)
      )
   )
   (if (and RETURN WI_TOG)
      (progn
         (set_tile "width" "1")
         (mode_tile "w_edit" 0)
      )
   )
   (if (and RETURN ST_TOG)
      (progn
         (set_tile "style" "1")
         (mode_tile "s_edit" 0)
         (mode_tile "ss_poppup" 0)
      )
   )
   (if (and RETURN RO_TOG)
      (progn
         (set_tile "rotation" "1")
         (mode_tile "r_edit" 0)
         (mode_tile "rp_button" 0)
      )
   )
   (setq RETURN (start_dialog))
)
;end initialization


;toggle button actions - if toggle is on=true; if off=false
(defun WITOG (VAL)
   (if (= 1 (atoi VAL))
      (progn
         (mode_tile "w_edit" 0)        ;true
         (setq WI_TOG t)
      )
      (progn (mode_tile "w_edit" 1) (setq WI_TOG nil))     ;false
   )
)
(defun HTTOG (VAL)
   (if (= 1 (atoi VAL))
      (progn
         (mode_tile "h_edit" 0)        ;true
         (mode_tile "hp_button" 0)
         (setq HT_TOG t)
      )
      (progn
         (mode_tile "h_edit" 1)
         (mode_tile "hp_button" 1)
         (setq HT_TOG nil)
      )     ;false
   )
)
(defun ROTOG (VAL)
   (if (= 1 (atoi VAL))
      (progn
         (mode_tile "r_edit" 0)
         (mode_tile "rp_button" 0)
         (setq RO_TOG t)
      )          ;true
      (progn
         (mode_tile "r_edit" 1)
         (mode_tile "rp_button" 1)
         (setq RO_TOG nil)
      )       ;false
   )
)
(defun STTOG (VAL)
   (if (= 1 (atoi VAL))
      (progn
         (mode_tile "s_edit" 0)
         (mode_tile "ss_poppup" 0)
         (setq ST_TOG t)
      )    ;true
      (progn
         (mode_tile "s_edit" 1)
         (mode_tile "ss_poppup" 1)
         (setq ST_TOG nil)
      )       ;false
   )
)
;end of toggle button actions

; edit box definitions
(defun W_EDIT (VAL)
   (if (not (<= (atof VAL) 0)) ; if not negative value
      (set_tile "w_edit" (setq NEWWID (rtos (atof VAL)))) ; true-update edit box
      (progn
         (set_tile "w_edit" NEWWID)                  ;false-reset edit box
         (set_tile
            "error"
            "Invalid width - resetting to previous setting!"    ; & display error message
         )
      )
   )
)
(defun H_EDIT (VAL)
   (if (not (<= (atof VAL) 0)) ; if not negative value 
      (set_tile "h_edit" (setq NEWHEI (rtos (atof VAL)))) ;true-update edit box
      (progn
         (set_tile "h_edit" NEWHEI)                  ; false-reset edit box
         (set_tile
            "error"                                 ; & display error message  
            "Invalid height - resetting to previous setting!"
         )
      )
   )
)
(defun S_EDIT (VAL)
   (if (tblsearch "style" (strcase VAL)) ; if specified style exists
      (progn
         (set_tile "s_edit" (setq NEWSTY (strcase VAL))) ; true-update edit box
         (set_tile "ss_poppup" (itoa (GETINDEX NEWSTY SLIST)))
      ) ;& popup list
      (progn
         (set_tile "s_edit" NEWSTY)      ; false-reset edit box
         (set_tile
            "error"                     ; & display error message
            "Invalid style - resetting to previous setting!"
         )
      )
   )
)
(defun R_EDIT (VAL)
   (setq NVAL (atof VAL))
   (if (>= (abs NVAL) 360)
      (setq GREQ t)
      (setq GREQ nil)
   )
   (if (< NVAL 0) (setq NEG t) (setq NEG nil))
   ;if neg is not nil then angle is negative 
   ;if neg is nil then angle is pos
   ;if greq is not nil then angle is greater than or equal to 360 degrees
   ;if greq is nil then angle is less than 360 degrees
   (if (and NEG (not GREQ))
      (setq
         NEWROT  (+ 360.0 NVAL)
         IRELAND 1
      )
   )
   (if (and GREQ (not NEG))
      (setq
         NEWROT (- NVAL 360.0)
         RELAND 2
      )
   )
   (if (and GREQ NEG)
      (setq
         NEWROT  (- 360 (abs (+ 360 NVAL)))
         IRELAND 3
      )
   )
   (if (and (not GREQ) (not NEG)) (setq NEWROT NVAL))
   (set_tile
      "r_edit"
      (setq NEWROT (rtos NEWROT))
   )
)
(defun HP_BUTTON ()
   (if NEWHEI
      (setq
         NEWHEI (rtos
                   (getdist
                      (strcat
                         "\nNew height<"
                         NEWHEI
                         ">:  "
                      )
                   )
                )
      )
      (setq NEWHEI (rtos (getdist "\nNew height <>:  ")))
   )
)
(defun RP_BUTTON ()
   (setq V VAL)
   (if NEWROT
      (setq
         NEWROT (rtos
                   (RTD
                      (getangle
                         (strcat
                            "\nNew angle<"
                            NEWROT
                            ">:  "
                         )
                      )
                   )
                )
      )
      (setq
         NEWROT (rtos (RTD (getangle "\nNew angle <>:  ")))
      )
   )
)

;style popup list action
(defun SS_POP_ACT (VAL)
   (set_tile "s_edit" (setq NEWSTY (nth (atoi VAL) SLIST)))
)

;style poppup list init function
(defun ST_LIST ()
   (setq SLIST (list (cdr (assoc 2 (tblnext "STYLE" t)))))
   (while (setq SNAME (cdr (assoc 2 (tblnext "STYLE"))))
      (if (/= SNAME "")
         (setq SLIST (cons SNAME SLIST))
      )
   )
   (setq SLIST (ACAD_STRLSORT SLIST))  ; alphabetize style list
   (if SLIST
      (progn
         (start_list "ss_poppup")
         (mapcar 'add_list SLIST)
         (end_list)
         (set_tile
            "ss_poppup"
            (itoa (GETINDEX NEWSTY SLIST))
         )
      )
   )
) ;end st_list function
(defun GETINDEX (ITEM ITEMLIST / M N)
   (setq N (length ITEMLIST))
   (if (> (setq M (length (member ITEM ITEMLIST))) 0)
      (- N M)
      nil
   )
)
(defun OK_BUTTON (SS_TXT)
   ;(ss_txt / tst count cent )
   (setq TST t)
   (setq SS SS_TXT)
   (if (and HT_TOG (= NEWHEI nil))
      (setq TST nil)
   )
   (if (and RO_TOG (= NEWROT nil)) (setq TST nil))
   (if (and WI_TOG (= NEWWID nil))
      (setq TST nil)
   )
   (if (and ST_TOG (= NEWSTY nil)) (setq TST nil))
   (if TST
      (progn
         (setq RETURN nil)
         (setq COUNT -1)
         (repeat
            (sslength SS_TXT)
            (WORKING)
            (setq COUNT (1+ COUNT))
            (if HT_TOG
               (TXT_CHG
                  (entget (ssname SS_TXT COUNT))
                  40
                  (atof NEWHEI)
               )
            )
            (if RO_TOG
               (TXT_CHG
                  (entget (ssname SS_TXT COUNT))
                  50
                  (DTR (atof NEWROT))
               )
            )
            (if WI_TOG
               (TXT_CHG
                  (entget (ssname SS_TXT COUNT))
                  41
                  (atof NEWWID)
               )
            )
            (if ST_TOG
               (TXT_CHG
                  (entget (ssname SS_TXT COUNT))
                  7
                  NEWSTY
               )
            )
         ) ;repeat 
      )
   ) ;progn/if
) ;end ok_button

;change text
(defun TXT_CHG (ENT NUM NVAL)
   (setq NV NVAL)
   (setq NM NUM)
   (entmod
      (setq
         NEWENT (subst (cons NUM NVAL) (assoc NUM ENT) ENT)
      )
   )
) ;defun txt_chg
(defun *error* () (ALT_ERR))
(defun ALT_ERR ()
   (setq *error* OLDERR)        ;reset error function to orig status
   (command "_undo" "_end")       ;end the undo function
   (setvar "cmdecho" 0)
)
(defun C:DDCHTXT ()
   ;(/ ss_txt)
   (setq OLDERR *error*) ;save error function
   (setvar "cmdecho" 0) ;make function transparent to user
   (if NOTRANS (NOTRANS)) ;do not run in transparent mode
   (command "_undo" "_m")                ;start undo-begin so that an 'undo'
   (setq SS_TXT (ssget '((0 . "text")))) ;will undo only this command 
   (setq RETURN 5)
   (setq
      HT_TOG nil
      WI_TOG nil
      ST_TOG nil
      RO_TOG nil
   )
   (while (and (< RETURN 6) (> RETURN 0))
      (INIT)
      (if (= RETURN 1) (OK_BUTTON SS_TXT)) ;ok button picked
      (if (= RETURN 2) (setq RETURN nil)) ;cancel picked
      (if (= RETURN 3) (HP_BUTTON)) ;height pick button picked
      (if (= RETURN 4) (RP_BUTTON)) ;rotation pick button picked
   ) ;while
   (ALT_ERR)
) ;end
(princ)