; Copyright 2000 Design Pacifica and EMT Software, Inc.
;
(defun C:DETAIL   (/ #CLAYER #CECOLOR #OSNP #STD
                     #ECHO #OLD_ERROR #LANG
                     cad_str_1@  cad_str_merge@  cad_to_str@  cad_error@
                     cad_detail@  cad_polar_trim@)

  (defun cad_error@ (%A)
    (setq *error* #OLD_ERROR)
    (setvar "cmdecho" #ECHO)
    (setvar "osmode" #OSNP)
    (setvar "clayer" #CLAYER)
    (setvar "cecolor" #CECOLOR)

    (cond
      ((= %A (cad_str_1@ 1 "Function cancelled" nil #LANG)) nil)
      (T (princ (cad_str_1@ 2 "\nerror: %0:\n" (list %A) #LANG))))
    (princ))

  (defun cad_detail@ (%A / #ANG #ARC0_ENT #ASCII #CIR0 #DET_BLK #DETAIL #DETMODE
		     #DIMSCALE #DIV #DT1 #DT2 #EDATA0 #EDATA1 #ENAME0 #ENAME1 #ENT
		     #ENTLAST0 #ENTLAST1 #PT #PT_LIST #PT0 #PT1 #RAD #RAD0 #SCALE #TMPLAY
		     #SCALE_REL #SCALE_STR #SIZEFLD #SIZETBL #SS0 #SS1 #SSLENGTH0 #SSLENGTH1
		     #SSLST #TMP #TYPE #TXTSIZE1 #TXTSIZE2 #UCSSET #X #CHK-TXT
                     @BLK @CHK-TXT @DETAIL-0 @DETAIL-1 @DETAIL @MAKE-PLINE @SS @SSLST)
    
    (defun @BLK (%SSLST / #X)
      (entmake (list '(0 . "BLOCK") '(2 . "*XXX") '(70 . 1) (cons 10 #PT0)))
      (foreach #X %SSLST (entmake #X))
      (entmake '((0 . "ENDBLK"))))
    
    (defun @CHK-TXT (%A)
      (setq #EDATA (entget %A)
	    #BOX (textbox #EDATA)
	    #P0 (cdr (assoc 10 #EDATA))
	    #P1 (list (+ (car #P0) (caar #BOX)) (+ (cadr #P0) (cadar #BOX)))
	    #P2 (polar #P1 0 (- (caadr #BOX) (caar #BOX)))
	    #P3 (polar #P2 (* 0.5 pi) (+ (cadar #BOX) (cadadr #BOX)))
	    #P4 (polar #P1 (* 0.5 pi) (+ (cadar #BOX) (cadadr #BOX))))
      (if (or (> (distance #PT0 #P1) #RAD)
	      (> (distance #PT0 #P2) #RAD)
	      (> (distance #PT0 #P3) #RAD)
	      (> (distance #PT0 #P4) #RAD))
	(entdel %A)))
    
    (defun @DETAIL-0 (%B / #ANG #PI/2)
      (setq #PI/2 (* 0.5 pi)
	    #RAD (distance #PT0 %B)
	    #ANG (angle #PT0 %B))
      (entmake (list '(0 . "BLOCK") '(2 . "*XXX") '(70 . 1) (cons 10 #PT0)))
      (entmake (list '(0 . "CIRCLE") (cons 10 #PT0) (cons 40 #RAD)))
      (if (/= #DETMODE 3)
	(entmake (list '(0 . "TEXT") '(10 0 0 0)
		       (cons 11 (polar #PT0 #ANG (+ #RAD (* 1.5 #TXTSIZE2))))
		       (cons 40 #TXTSIZE2) (cons 1 #DETAIL) '(71 . 0) '(72 . 4))) )
      (entmake (list '(0 . "INSERT") (cons 2 (entmake '((0 . "ENDBLK"))))
		     (cons 10 #PT0))))
    
    (defun @DETAIL-1 (%B / #ANG #ARCLEN #ASZ/6 #ENDANG #ENDARW #ENDPT #IANG
		      #PI/2 #STARTANG #STARTARW #STARTPT)
      (setq #PI/2 (* 0.5 pi)
	    #ASZ/6 (/ #ASZ 6.0)
	    #RAD (distance #PT0 %B)
	    #ANG (angle #PT0 %B)
	    #ARCLEN (* 2.4 (+ #ASZ #TXTSIZE2))
	    #IANG (/ #ARCLEN #RAD)
	    #STARTANG (+ #ANG (* 0.5 #IANG))
	    #ENDANG (- #ANG (* 0.5 #IANG))
	    #STARTPT (polar #PT0 #STARTANG #RAD)
	    #ENDPT (polar #PT0 #ENDANG #RAD)
	    #STARTARW (angle #STARTPT %B)
	    #ENDARW (angle #ENDPT %B))
      (if (> #STARTANG (* 2.0 pi)) (setq #STARTANG (- #STARTANG (* 2.0 pi))))
      (if (minusp #ENDANG) (setq #ENDANG (+ #ENDANG (* 2.0 pi))))
      (entmake (list '(0 . "BLOCK") '(2 . "*XXX") '(70 . 1) (cons 10 #PT0)))
      (entmake (list '(0 . "ARC") (cons 10 #PT0) (cons 40 #RAD)
		     (cons 50 #STARTANG) (cons 51 #ENDANG)))
      (entmake (list '(0 . "TEXT") '(10 0 0 0)
		     (cons 11 %B) (cons 40 #TXTSIZE2) (cons 1 #DETAIL) '(71 . 0) '(72 . 4)))
      (entmake (list '(0 . "SOLID")
		     (cons 10 (polar #STARTPT #STARTARW #ASZ))
		     (cons 11 (polar #STARTPT (+ #STARTARW #PI/2) #ASZ/6))
		     (cons 12 (polar #STARTPT (- #STARTARW #PI/2) #ASZ/6))
		     (cons 13 (polar #STARTPT (- #STARTARW #PI/2) #ASZ/6))))
      (entmake (list '(0 . "SOLID")
		     (cons 10 (polar #ENDPT #ENDARW #ASZ))
		     (cons 11 (polar #ENDPT (+ #ENDARW #PI/2) #ASZ/6))
		     (cons 12 (polar #ENDPT (- #ENDARW #PI/2) #ASZ/6))
		     (cons 13 (polar #ENDPT (- #ENDARW #PI/2) #ASZ/6))))
      (entmake (list '(0 . "INSERT") (cons 2 (entmake '((0 . "ENDBLK"))))
		     (cons 10 #PT0))))
    
    (defun @MAKE-PLINE (%A / #EDATA #P0 #P1 #P2 #P3)
      (setq #EDATA (entget %A)
	    #P0 (cdr (assoc 10 #EDATA))
	    #P1 (cdr (assoc 11 #EDATA))
	    #P2 (cdr (assoc 12 #EDATA))
	    #P3 (cdr (assoc 13 #EDATA)))
      (if (or (> (distance #PT0 #P0) #RAD)
	      (> (distance #PT0 #P1) #RAD)
	      (> (distance #PT0 #P2) #RAD)
	      (> (distance #PT0 #P3) #RAD))
	(progn
	  (entdel %A)
	  (command "_.pline" #P0 #P1 #P2)
	  (if (equal #P2 #P3) (command "_c") (command #PT3 "_c"))
	  (setq #EDATA (entget (entlast)))
	  (if #LTYPE (setq #EDATA (subst #LTYPE (assoc 6 #EDATA) #EDATA)))
	  (if #LAYER (setq #EDATA (subst #LAYER (assoc 8 #EDATA) #EDATA)))
	  (if #COLOR (setq #EDATA (subst #COLOR (assoc 62 #EDATA) #EDATA)))
	  (entmod #EDATA)
	  (entlast))
	%A))
    
    (defun @SS (%A / #ENTNEXT #SS)
      (setq #ENTNEXT %A)
      (setq #SS (ssadd))
      (while (setq #ENTNEXT (entnext #ENTNEXT))
	(if (not (member (cdr (assoc 0 (entget #ENTNEXT)))
			 '("ATTRIB" "SEQEND" "VERTEX")))
	  (setq #SS (ssadd #ENTNEXT #SS))))
      (eval #SS))
    
    (defun @SSLST (%SS / #COUNT #ENAME #SSLST)
      (setq #COUNT 0)
      (repeat (sslength %SS)
	(setq #ENAME (ssname %SS #COUNT)
	      #SSLST (cons (entget #ENAME) #SSLST)
	      #COUNT (1+ #COUNT))
	(entdel #ENAME))
      #SSLST)
    
    (setq #SIZEFLD "SIZE-X"
	  #DETMODE %A)
    (cond
      ((= #DETMODE 1) (setq @DETAIL @DETAIL-1 #DIV "/"))
      ((= #DETMODE 2) (setq @DETAIL @DETAIL-0 #DIV ":"))
      ((= #DETMODE 3) (setq @DETAIL @DETAIL-0 #DIV ":"))
      (T (setq @DETAIL @DETAIL-0 #DIV ":")))
    (setq #ANG 0.0
	  #DIMSCALE (getvar "dimscale"))
    (setq #ASZ (* (getvar "dimasz") #DIMSCALE)
	  #TXTSIZE1 (* (getvar "dimtxt") #DIMSCALE)
	  #TXTSIZE2 (* (* (getvar "dimtxt") 0.75) #DIMSCALE)
	  #ASCII 65)
    (while (not #DETAIL)
      (setq #DETAIL (chr #ASCII))
      (if (ssget "_X" (list (cons 2 (strcat "DETAIL-" #DETAIL))))
	(setq #DETAIL nil #ASCII (1+ #ASCII))))
    (setq #TMP
	   (getstring (cad_str_1@ 226 "\nDetail name <%0>: " (list #DETAIL) #LANG)))
    (if (/= #TMP "") (setq #DETAIL (strcase #TMP)))
    (initget 1)
    (if (not (and (equal (getvar "ucsorg") '(0 0 0))
		  (equal (getvar "ucsxdir") '(1 0 0))
		  (equal (getvar "ucsydir") '(0 1 0))))
      (progn
	(setq #UCSSET T)
	(princ (cad_str_1@ 234 "\nSwitching to World UCS." nil #LANG))
	(command "_.ucs" "_w")))
    (setq #PT0 (getpoint (cad_str_1@ 227 "\nCenter of detail area: " nil #LANG))
	  #PT0 (list (car #PT0) (cadr #PT0))
	  #DT1 #PT0)
    (initget 1)
    (setq #PT0_RAD (getpoint #PT0 (cad_str_1@ 228 "\nRadius point: " nil #LANG))
	  #PT #PT0_RAD)
    (@DETAIL #PT)
    (while #PT
      (setq #PT (getpoint #PT0 (cad_str_1@ 231 "\nRadius point <OK>: " nil #LANG)))
      (if #PT
	(progn
	  (entdel (entlast))
	  (@DETAIL #PT)
	  (setq #PT0_RAD #PT))))
    (setq #CIR0 (entlast) #RAD0 (distance #PT0 #PT0_RAD))
    (princ (cad_str_1@ 233 "\nMaking clipped detail... " nil #LANG))
    (repeat 72
      (setq #PT_LIST (cons (polar #PT0 #ANG #RAD0) #PT_LIST)
	    #ANG (+ #ANG (/ pi 36))))
    (setq #SS0 (ssget "_CP" #PT_LIST))
    (ssdel #CIR0 #SS0)
    (setq #SSLENGTH0 (sslength #SS0))
    ;create copy and enlarge
    (setq #ENTLAST0 (entlast))
    (cond
      ((= (getvar "undoctl") 0) (command "_.undo" "_A"))
      ((= (getvar "undoctl") 3) (command "_.undo" "_C" "_A")))
    (command "_.undo" "_m")
    (command "_.copy" #SS0 "" '(0 0) '(0 0))
    (setq #EXPLODE T)
    ;explode all entites and rebuild selection set
    (while #EXPLODE
      (setq #EXPLODE nil
	    #SS1 (@SS #ENTLAST0)
	    #SSLENGTH1 (sslength #SS1)
	    #COUNT 0)
      (repeat #SSLENGTH1
	(setq #EDATA0 (entget (setq #ENAME0 (ssname #SS1 #COUNT)))
	      #TYPE (cdr (assoc 0 #EDATA0))
	      #LTYPE (assoc 6 #EDATA0)
	      #LAYER (assoc 8 #EDATA0)
	      #COLOR (assoc 62 #EDATA0)
	      #ENTLAST1 (entlast))
	(if (or (member #TYPE
			'("BODY" "3DFACE" "3DSOLID" "DIMENSION" "HATCH" "LWPOLYLINE" "POLYLINE" "REGION"))
		(and (= #TYPE "INSERT")
		     (= (cdr (assoc 41 #EDATA0))
			(cdr (assoc 42 #EDATA0))
			(cdr (assoc 43 #EDATA0))))
		(and (= #TYPE "SOLID")
		     (/= #ENAME0 (setq #ENAME0 (@MAKE-PLINE #ENAME0)))))
	  (progn
	    (setq #EXPLODE T)
	    (if (not #LTYPE) (setq #LTYPE (cons 6 V:BYLAYER)))
	    (if (not #COLOR) (setq #COLOR '(62 . 256)))
	    (command "_.explode" #ENAME0)
	    ;fix ltype, layer, and color of new entities from explode
	    (while (setq #ENAME1 (entnext #ENTLAST1))
	      (setq #EDATA1 (entget #ENAME1))
	      (if (= (cdr (assoc 6 #EDATA1)) V:BYBLOCK)
		(setq #EDATA1 (subst #LTYPE (assoc 6 #EDATA1) #EDATA1)))
	      (if (member (cdr (assoc 8 #EDATA1)) '("0" "DEFPOINTS"))
		(setq #EDATA1 (subst #LAYER (assoc 8 #EDATA1) #EDATA1)))
	      (if (= (cdr (assoc 62 #EDATA1)) 0)
		(setq #EDATA1 (subst '(62 . 256) (assoc 62 #EDATA1) #EDATA1)))
	      (entmod #EDATA1)
	      (setq #ENTLAST1 #ENAME1)))
	  (progn
	    (if (not #COLOR)
	      (progn
		(setq #TMPLAY (tblsearch "LAYER" (cdr #LAYER)))
		(setq #COLOR (assoc 62 #TMPLAY))
		(setq #EDATA0 (append #EDATA0 (list #COLOR)))
		(entmod #EDATA0))) ))
	(if (= #TYPE "ATTDEF") (entdel #ENAME0))
	(if (= #TYPE "TEXT") (@CHK-TXT #ENAME0))
	(setq #COUNT (1+ #COUNT))))
    ;trim items
    (setq #COUNT 0)
    (command "_.circle" #PT0 #RAD0)
    (setq #CIR1 (entlast))
    (repeat #SSLENGTH1
      (cad_polar_trim@ #CIR1 (ssname #SS1 #COUNT))
      (setq #COUNT (1+ #COUNT)))
    (entdel #CIR1)
    (setq #SS1 (@SS #ENTLAST0)
	  #SSLST (@SSLST #SS1))
    (if (> #SSLENGTH0 0) (command "_.undo" "_be"))
    (setq #DET_BLK (@BLK #SSLST))
    ;redraw original entities
    (setq #COUNT 0)
    (repeat #SSLENGTH0
      (redraw (ssname #SS0 #COUNT))
      (setq #COUNT (1+ #COUNT)))
    (redraw #CIR0)
    (initget 6)
    (setq #SCALE_DEF 2.0
	  #SCALE_REL (getreal
		       (cad_str_1@ 229 "\nRelative scale factor <%0>: " (list #SCALE_DEF) #LANG)))
    (initget 0)
    (if (not #SCALE_REL) (setq #SCALE_REL #SCALE_DEF))
    (while #PT0
      (if #PT1
	(progn
	  (command "_.circle" #PT1 (* #RAD0 #SCALE_REL))
	  (entmake (list '(0 . "INSERT") (cons 2 #DET_BLK)
			 (cons 10 #PT0) (cons 41 #SCALE_REL) (cons 42 #SCALE_REL)
			 (cons 43 #SCALE_REL)))))
      (setq #PT0 (getpoint (cad_str_1@ 230 "\nCenter of scaled detail: " nil #LANG)))
      (cond
	((and #PT0 #PT1) (entdel (entlast)) (entdel (entlast)) (setq #PT1 #PT0))
	(#PT0 (setq #PT1 #PT0))))
    (if #PT1
      (progn
	(setq #SCALE (* #SCALE_REL (getvar "dimscale"))
	      #SCALE_STR (rtos #SCALE 5))
	(if (>= #SCALE 1.0) (setq #SCALE_STR (strcat #SCALE_STR #DIV "1")))
	(if (> #SSLENGTH0 0)
	  (command "_.explode" "_l"))
	(cond
	  ((= #DETMODE 1)
	   (setq #STR (strcat "{\\H" (rtos #TXTSIZE2) (cad_str_1@ 558 "DETAIL" nil #LANG)
			      " " #DETAIL "}\\P{\\H" (rtos #TXTSIZE1) (cad_str_1@ 13 "SCALE" nil #LANG)
			      ": " #SCALE_STR "}")
		 #PT1 (polar #PT1 (* 1.5 pi)
			     (+ (* #RAD0 #SCALE_REL) (* 0.5 #TXTSIZE2))))
	   (entmake (list '(0 . "MTEXT") '(100 . "AcDbEntity")
			  '(100 . "AcDbMText") (cons 10 #PT1) (cons 40 #TXTSIZE1)
			  '(71 . 2) '(72 . 1) (cons 1 #STR))))
	  ((= #DETMODE 2)
	   (setq #STR (strcat "{\\H" (rtos #TXTSIZE2) #DETAIL " " #SCALE_STR "}")
		 #PT1 (polar #PT1 (* 0.5 pi)
			     (+ (* #RAD0 #SCALE_REL) (* 0.5 #TXTSIZE2))))
	   (entmake (list '(0 . "MTEXT") '(100 . "AcDbEntity")
			  '(100 . "AcDbMText") (cons 10 #PT1) (cons 40 #TXTSIZE2)
			  '(71 . 8) '(72 . 1) (cons 1 #STR))))
	  ((= #DETMODE 3)
	   (setq #STR (strcat "{\\H" (rtos #TXTSIZE2) (cad_str_1@ 558 "DETAIL" nil #LANG)
			      " " #DETAIL "}\\P{\\H" (rtos #TXTSIZE1) "(" #SCALE_STR ")}")
		 #DT2 #PT1
		 #PT1 (polar #PT1 (* 1.5 pi)
			     (+ (* #RAD0 #SCALE_REL) (* 0.5 #TXTSIZE2))))
	   (entmake (list '(0 . "LINE")
			  (cons 10 (polar #DT1 (angle #DT1 #DT2) #RAD))
			  (cons 11 (polar #DT2 (angle #DT2 #DT1) (* #SCALE #RAD0)))))
	   (entmake (list '(0 . "MTEXT") '(100 . "AcDbEntity")
			  '(100 . "AcDbMText") (cons 10 #PT1) (cons 40 #TXTSIZE2)
			  '(71 . 2) '(72 . 1) (cons 1 #STR))))
	  (T ;DETMODE=0
	   (setq #STR (strcat "{\\H" (rtos #TXTSIZE2) #DETAIL " (" #SCALE_STR ")}")
		 #PT1 (polar #PT1 (* 0.5 pi)
			     (+ (* #RAD0 #SCALE_REL) (* 0.5 #TXTSIZE2))))
	   (entmake (list '(0 . "MTEXT") '(100 . "AcDbEntity")
			  '(100 . "AcDbMText") (cons 10 #PT1) (cons 40 #TXTSIZE2)
			  '(71 . 8) '(72 . 1) (cons 1 #STR)))))))
    (if #UCSSET
      (progn
	(princ (cad_str_1@ 235 "\nRestoring UCS." nil #LANG))
	(command "_.ucs" "_p"))))

  (defun cad_polar_trim@ (%A %B / #ANG #CEN0 #CEN1 #DIST0 #DIST1 #EDATA0 #EDATA1
			 #ETYPE #IN #INTERS0 #INTERS1 #PT0 #PT1 #RAD0 #RAD1 #X #CEN0_TMP #PT0_TMP #PT1_TMP)
    (setq #EDATA0 (entget %A)
	  #EDATA1 (entget %B)
	  #CEN0 (cdr (assoc 10 #EDATA0))
	  #RAD0 (cdr (assoc 40 #EDATA0))
	  #ETYPE (cdr (assoc 0 #EDATA1)))
    (cond
      ((= #ETYPE "ARC")
       (setq #CEN1 (cdr (assoc 10 #EDATA1))
	     #CEN1 (list (car #CEN1) (cadr #CEN1))
	     #DIST0 (distance #CEN0 #CEN1)
	     #RAD1 (cdr (assoc 40 #EDATA1))
	     #PT0 (polar #CEN1 (cdr (assoc 50 #EDATA1)) #RAD1)
	     #PT1 (polar #CEN1 (cdr (assoc 51 #EDATA1)) #RAD1))
       (cond
	 ((not (equal (assoc 210 #EDATA0) (assoc 210 #EDATA1))) (entdel %B))
	 ((<= (+ #DIST0 #RAD1) #RAD0) nil)
	 ((>= (- #DIST0 #RAD1) #RAD0) (entdel %B))
	 (T
	  (if (> (distance #CEN0 #PT0) #RAD0)
	    (command "_.trim" %A "" (list %B #PT0) ""))
	  (if (> (distance #CEN0 #PT1) #RAD0)
	    (command "_.trim" %A "" (list %B #PT1) ""))
	  (if (and (< (distance #CEN0 #PT0) #RAD0)
		   (< (distance #CEN0 #PT1) #RAD0))
	    (command "_.trim" %A "" (list %B
					  (polar #CEN0 (angle #CEN0 #CEN1) (+ #DIST0 #RAD1))) ""))
	  (if (and (equal (entget %B) #EDATA1)
		   (>= (distance #CEN0 #PT0) #RAD0)
		   (>= (distance #CEN0 #PT1) #RAD0)) (entdel %B)))))
      ((= #ETYPE "CIRCLE")
       (setq #CEN1 (cdr (assoc 10 #EDATA1))
	     #CEN1 (list (car #CEN1) (cadr #CEN1))
	     #DIST0 (distance #CEN0 #CEN1)
	     #RAD1 (cdr (assoc 40 #EDATA1)))
       (cond
	 ((not (equal (assoc 210 #EDATA0) (assoc 210 #EDATA1))) (entdel %B))
	 ((<= (+ #DIST0 #RAD1) #RAD0) nil)
	 ((>= (- #DIST0 #RAD1) #RAD0) (entdel %B))
	 ((<= (+ #DIST0 #RAD0) #RAD1) (entdel %B))
	 (T (command "_.trim" %A "" (list %B
					  (polar #CEN0 (angle #CEN0 #CEN1) (+ #DIST0 #RAD1))) ""))))
      ((= #ETYPE "LINE")
       (setq #PT0 (cdr (assoc 10 #EDATA1))
	     #PT1 (cdr (assoc 11 #EDATA1))
	     #ANG (angle #PT0 #PT1))
       
       (setq #CEN0_TMP (list (car #CEN0) (cadr #CEN0))
	     #PT0_TMP (list (car #PT0) (cadr #PT0))
	     #PT1_TMP (list (car #PT1) (cadr #PT1)))
       (setq
	 #DIST0 (distance #CEN0_TMP #PT0_TMP)
	 #DIST1 (distance #CEN0_TMP #PT1_TMP)
	 #INTERS0 (inters #CEN0 (polar #CEN0 (+ #ANG (* 0.5 pi)) #RAD0)
			  #PT0 #PT1)
	 #INTERS1 (inters #CEN0 (polar #CEN0 (+ #ANG (* 0.5 pi)) #RAD0)
			  #PT0 #PT1 nil))
       (if (not #INTERS0)
	 (setq #INTERS0 (inters #CEN0 (polar #CEN0 (- #ANG (* 0.5 pi)) #RAD0)
				#PT0 #PT1)))
       (cond
	 ((and (<= #DIST0 #RAD0) (<= #DIST1 #RAD0)) nil)
	 ((and (>= #DIST0 #RAD0) (>= #DIST1 #RAD0) (not #INTERS0)) (entdel %B))
	 ((and #INTERS1 (>= (distance #CEN0 #INTERS1) #RAD0)) (entdel %B))
	 (T
	  (if (>= #DIST0 #RAD0) (command "_.trim" %A "" (list %B #PT0) ""))
	  (if (>= #DIST1 #RAD0) (command "_.trim" %A "" (list %B #PT1) "")))))
      ((= #ETYPE "POINT")
       (if (> (distance #CEN0 (cdr (assoc 10 #EDATA1))) #RAD0)
	 (entdel %B)))
      ((= #ETYPE "SPLINE")
       (foreach #X #EDATA1
	 (if (= (car #X) 10)
	   (progn
	     (setq #PT0 (list (cadr #X) (caddr #X))
		   #DIST0 (distance #CEN0 #PT0))
	     (if (< #DIST0 #RAD0) (setq #IN T)))))
       (if #IN
	 (foreach #X #EDATA1
	   (if (= (car #X) 10)
	     (progn
	       (setq #PT0 (list (cadr #X) (caddr #X))
		     #DIST0 (distance #CEN0 #PT0))
	       (if (>= #DIST0 #RAD0) (command "_.trim" %A "" (list %B #PT0) "")))))
	 (entdel %B)))))

  (defun cad_str_1@ (%A %B %C %D / #STRING #STR)
    (setq #STR (list (list 1 "Function canceled" "֐ݾق܂")
		     (list 2 "\nerror: %0:\n" "\nװ: %0:\n")
		     (list 13 "SCALE" "ړx")
		     (list 226 "\nDetail name <%0>: " "\nڍא} <%0>: ")
		     (list 227 "\nCenter of detail area: " "\nڍא}̈̒Sw: ")
		     (list 228 "\nRadius point: " "\na: ")
		     (list 229 "\nRelative scale factor <%0>: " "\nΎړx <%0>: ")
		     (list 230 "\nCenter of scaled detail: " "\nړx̂ڍא}̒S: ")
		     (list 231 "\nRadius point <OK>: " "\n̔ałł <OK>: ")
		     (list 232 "\nLetter %0 already used." "\n %0 ͊ɎgĂ܂.")
		     (list 233 "\nMaking clipped detail... " "\nڍא}؎肵Ă܂... ")
		     (list 234 "\nSwitching to World UCS." "\nܰލWnɕύX.")
		     (list 235 "\nRestoring UCS." "\nհލWnĂяo܂.")
		     (list 558 "DETAIL" "ڍ")))
    (if %A
      (cond
	((= %D 2) (setq #STRING (caddr (assoc %A #STR))))
	(T        (setq #STRING (cadr (assoc %A #STR)))))
      (setq #STRING %A))
    (if %C (cad_str_merge@ #STRING %C) #STRING))

  (defun cad_str_merge@ (%A %B / #CHAR #CHAR-1 #CHAR+1 #COUNT #STRING #STRLEN)
    (setq #STRING "" #CHAR-1 "" #COUNT 1)
    (setq #STRLEN (strlen %A))
    (while (>= #STRLEN #COUNT)
      (setq #CHAR (substr %A #COUNT 1))
      (if (and (= #CHAR "%") (/= #CHAR-1 "%")
	       (< 47 (ascii (setq #CHAR+1 (substr %A (1+ #COUNT) 1))) 58))
	(setq #STRING (strcat #STRING (cad_to_str@ (nth (atoi #CHAR+1) %B)))
	      #COUNT (+ #COUNT 2))
	(setq #STRING (strcat #STRING #CHAR) #COUNT (1+ #COUNT))))
    #STRING)

  (defun cad_to_str@ (%A)
    (cond
      ((not %A) "")
      ((= (type %A) 'STR) %A)
      ((= (type %A) 'INT) (itoa %A))
      ((= (type %A) 'REAL) (rtos %A))))

 ;;; Set #LANG to (English = 1, Japanese = 2).
 (setq #LANG 1)

 ;;; Set #STD  to (ANSI =1, JIS = 2, OTHER =3).
 (setq #STD 1)

 (setq #OLD_ERROR *error*)
 (setq #ECHO (getvar "cmdecho"))
 (setq #OSNP (getvar "osmode"))
 (setq #CLAYER (getvar "clayer"))
 (setq #CECOLOR (getvar "cecolor"))

 (setq *error* cad_error@)
 (setvar "cmdecho" 0)
 (setvar "osmode" 0)

 (cad_detail@ #STD)

 (setq *error* #OLD_ERROR)
 (setvar "cmdecho" #ECHO)
 (setvar "osmode" #OSNP)
 (setvar "clayer" #CLAYER)
 (setvar "cecolor" #CECOLOR)

 (princ))


;;; Uncomment for the language needed.
;(princ "\n\nDETAIL͂ĊJn")  ; For Japanese.
(princ "\n\nType DETAIL to start.") ; For English.

(princ)
