;;------------> IZDELIE <-------------------------------------------------
;;
;;  Adding PG for AutoCAD r15
;;   
;;       
;;   (+ mdll.lsp, *.mdl)
;;  
;;    ..
;;   Copyright  \"SingleSoft PG\" "
;;                       mailto:gepos@mail.ru 
;;
;;------------------------------------------------------------------------
;;------------------------------------------------------------------------
;; 
;; Modeller
;;       
;;    ..
;;    r14-15  ..
;;
;-------------------------------------------------------------------------
(defun models (filnam)
   (setq api 0.0174533)
   (setq mfile (open (findfile filnam) "r"))
   (setq pnt (read (reastr)))
   (setq vec (cons '(0 0 0 0 0.0 0.0 0 0.0 0.0) (read (reastr))))
   (setq chn (read (reastr)))
   (prompt "\nNumber of variant: ") (setq num (getint))
   (setvar "CMDECHO" 0)
   (setvar "blipmode" 0)
   (setvar "OSMODE" 0)
   (REDRAW)
 (if (> num 0) (progn

   (setq strn (reastr))
     (while (/= strn nil)
       (setq strn (read strn))
       (set 'r (nth 0 strn))
       (set  r (float (eval (nth num strn))))
       (setq strn (reastr))
     )
  ))
   (close mfile)
   (setq nv (- (length vec) 1))
   (foreach v vec (evavec v))
   (solmod)
   (putpic)
   (setq pnt nil vec nil chn nil strn nil) (gc)
   (setvar "CMDECHO" 1)
   (setvar "BLIPMODE" 1)
 )
;-------------------------------------------------------------------------
(defun reastr ()
  (setq a (read-line mfile) strn a)
 (if (/= a nil) (progn
  (while (/= (substr  a (strlen a) 1) "!")
    (setq a (read-line mfile))
    (setq strn (strcat strn a ))
  )
  (setq strn (substr strn 1 (- (strlen strn) 1)))
  )
  (setq strn nil))
)
;-------------------------------------------------------------------------
(defun evavec (v)
(setq vec (subst (list (nth 0 v) (nth 1 v) (nth 2 v) (nth 3 v)
(if (/= (nth 4 v) nil) (eval (nth 4 v)) nil)
(if (/= (nth 5 v) nil) (* (eval (nth 5 v)) api) nil)
(nth 6 v)) v vec))
; (nth 6 v) (nth 7 v) (* (nth 8 v) api)) v vec))
)
;-------------------------------------------------------------------------
(defun solmod (/ vs vr vv dA tv)
 (while (/= chn nil)
  (setq cont (car chn) chn (cdr chn))

 (setq V1 nil V2 nil V3 nil)

  (while (/= cont nil)
 (setq v (car cont) vv (nth (abs v) vec) tv (detect vv) cont (cdr cont))
 (setq vs (list tv v (nth 4 vv) (nth 5 vv) (nth 6 vv) (nth 2 vv) (nth 3 vv)))
    (setq vr (sumvec V1 vs))
      (if (/= vr nil) (setq V1 vr)
      (progn
        (setq vr (sumvec V2 vs))
        (if (/= vr nil)  (setq V2 vr) (setq V3 (sumvec V3 vs)))
      ))
   )

  (if (and (/= V2 nil) (= V3 nil)) (progn
        (setq CA1 (nth 4 V1) CA2 (nth 4 V2))
        (if (< (nth 1 V2) 0) (setq dA 0.0) (setq dA pi))
          (cond ((and (= CA1 nil) (= CA2 nil))
                 (corvec      (nth 1 V1)  (list nil 0.0 (nth 1 V1)))
                 (corvec (abs (nth 1 V2)) (list nil dA  (nth 1 V1))))

   ((= CA1 nil) (corvec      (nth 1 V1)  (list nil (+ dA (nth 3 V2)) CA2)))
   ((= CA2 nil) (corvec (abs (nth 1 V2)) (list nil (+ dA (nth 3 V1)) CA1)))
           ((< CA1 CA2) (foreach v vec (reclas v dA CA1 CA2)))
           ((> CA1 CA2) (foreach v vec (reclas v dA CA2 CA1)))
          )
        (corvec      (nth 1 V1)  (list (nth 2 V2) nil nil))
        (corvec (abs (nth 1 V2)) (list (nth 2 V1) nil nil))
        (setq action t actall t nerr 0)
      ))

      (if (/= V3 nil) (progn
;   V1 V2 V3
;  V1  ,  V3  ,   
        (if (and (/= (nth 0 V3) 0) (= (nth 0 V1) 0))
        (setq buf V3 V3 V1 V1 buf))

;  V2  ,  V3  ,   
        (if (and (/= (nth 0 V3) 0) (= (nth 0 V2) 0))
        (setq buf V3 V3 V2 V2 buf))

        (if (and (= (nth 0 V1) (nth 0 V3))
                 (< (nth 4 V1) (nth 4 V3)))
        (setq buf V3 V3 V1 V1 buf))

        (if (and (= (nth 0 V2) (nth 0 V3))
                 (< (nth 4 V2) (nth 4 V3)))
        (setq buf V3 V3 V2 V2 buf))

        (setq CAB (nth 4 V3))

        (if (and (/= (nth 4 V1) CAB) (/= (nth 4 V1) nil))
        (setq V1 (cons (+ 2 (car V1)) (cdr V1))))

        (if (and (/= (nth 4 V2) CAB) (/= (nth 4 V2) nil))
        (setq V2 (cons (+ 2 (car V2)) (cdr V2))))

;      
           (cond ((and (= (nth 0 V1) 1) (= (nth 0 V2) 1))  (solRR))
                 ((and (= (nth 0 V1) 1) (= (nth 0 V2) 2))  (solAR V1 V2))
                 ((and (= (nth 0 V1) 2) (= (nth 0 V2) 1))  (solAR V2 V1))
                 ((and (= (nth 0 V1) 2) (= (nth 0 V2) 2))  (solAA))
           )
      ))
  )
)
;-------------------------------------------------------------------------
(defun solRR ( / A1 A2 A3 S1 S2 RR R1 R2 Rt)
;    V1, V2
  (setq A1 (nth 3 V1) A2 (nth 3 V2) A3 (nth 3 V3))
  (setq S1 (abs (sin (- A2 A3)))
        S2 (abs (sin (- A1 A3)))
        S3 (abs (sin (- A1 A2))))

  (if (not (equal S3 0.0 0.0001)) (progn
     (setq RR (/ (nth 2 V3) S3))
     (setq R1 (* RR S1) R2 (* RR S2))

  (if (/= (nth 0 V1) 0) (progn
     (setq  Rt (abs (nth 1 (nth (abs (nth 1 V1)) vec))))
     (if (> Rt 1)   (foreach v vec (subrad v R1 Rt))
                    (corvec (abs (nth 1 V1)) (list R1 nil nil)))
  ))
  (if (/= (nth 0 V2) 0) (progn
     (setq  Rt (abs (nth 1 (nth (abs (nth 1 V2)) vec))))
     (if (> Rt 1)   (foreach v vec (subrad v R2 Rt))
                    (corvec (abs (nth 1 V2)) (list R2 nil nil)))
  ))
  ))
)
;-------------------------------------------------------------------------
(defun solAR (vr1 vr2 / A1 A3 R2 R3 SdA Rt)
;    Vr1    Vr2
  (setq A1 (nth 3 vr1) A3 (nth 3 V3) R2 (nth 2 vr2) R3 (nth 2 V3))
    (if (< (nth 1 vr1) 0) (setq A1 (+ A1 pi)))
    (if (< (nth 1 vr2) 0) (setq R2 (- R2)))
    (if (< (nth 1 V3)  0) (setq R3 (- R3)))

    (setq SdA (/ (* R3 (sin (- A3 A1))) R2))
    (if (<= (abs SdA) 1.0) (progn
        (setq CdA (sqrt (- 1.0 (* Sda SdA))))
        (setq A21 (- A1 (atan SdA CdA)) A22 (- A1 (atan SdA (- CdA))))
        (setq C1 (cos A1) S1 (sin A1))

    (if (> (abs C1) 0.7)
        (setq R11 (- (/ (+ (* R2 (cos A21)) (* R3 (cos A3))) C1))
              R12 (- (/ (+ (* R2 (cos A22)) (* R3 (cos A3))) C1)))

        (setq R11 (- (/ (+ (* R2 (sin A21)) (* R3 (sin A3))) S1))
              R12 (- (/ (+ (* R2 (sin A22)) (* R3 (sin A3))) S1)))
    )
                           (setq R1 R11 A2 A21)
          (if (<= R11 0.0) (setq R1 R12 A2 A22))

          (setq CAB (subang vr2 A2 CAB))
  (if (/= (nth 0 vr1) 0) (progn
     (setq  Rt (abs (nth 1 (nth (abs (nth 1 vr1)) vec))))
     (if (> Rt 1)   (foreach v vec (subrad v R1 Rt))
                    (corvec (abs (nth 1 vr1)) (list R1 nil nil)))
  ))
  ))
)
;-------------------------------------------------------------------------
(defun solAA ( / R1 R2 R3 A1 A2 A3 S1 S2 C1 C2 dec p0 p1 p2 p3)
;    V1, V2

  (setq R1 (nth 2 V1) R2 (nth 2 V2) R3 (nth 2 V3) A3 (nth 3 V3))
    (if (< (nth 1 V2) 0) (setq R2 (- R2)))
    (if (< (nth 1 V3) 0) (setq R3 (- R3)))

  (setq C2 (/ (- (* R1 R1) (* R2 R2) (* R3 R3)) 2.0 R2 R3))
  (setq C1 (/ (- (+ R3 (* R2 C2))) R1))

  (if (and (<= (abs C1) 1.0) (<= (abs C2) 1.0)) (progn
      (setq p0 (cdr (assoc (nth 5 V2) pnt))
            p1 (cdr (assoc (nth 6 V2) pnt))
            p2 (cdr (assoc (nth 5 V3) pnt))
            p3 (cdr (assoc (nth 6 V3) pnt)))
      (setq dec (- (* (- (cadr p1) (cadr p0)) (- (car p3) (car p2)))
                   (* (- (cadr p3) (cadr p2)) (- (car p1) (car p0)))))

                      (setq S2 (sqrt (- 1 (* C2 C2))))
      (if (< dec 0.0) (setq S2 (- S2)))

                      (setq S1 (/ (* (- R2) S2) R1))
      (setq A1 (+ (atan S1 C1) A3) A2 (+ (atan S2 C2) A3))
      (setq CAB (subang V2 A2 CAB))
      (setq CAB (subang V1 A1 CAB))
  ))
)
;-------------------------------------------------------------------------
(defun sumvec (vb vv / vr A1 A2 Rs As CAs ps pbs pes)
   (setq vr nil)
   (if (= vb nil) (setq vr vv)
   (progn
     (if (and (= (car vb) 0)
              (= (car vv) 0)
              (= (nth 4 vb) (nth 4 vv)))
     (progn
         (if (< (nth 1 vb) 0)
             (setq A1 (+ pi (nth 3 vb)) pbs (nth 6 vb))
             (setq A1 (nth 3 vb) pbs (nth 5 vb)))

         (if (< (nth 1 vv) 0)
             (setq A2 (+ pi (nth 3 vv)) pes (nth 5 vv))
             (setq A2 (nth 3 vv) pes (nth 6 vv)))

     (setq ps (polar (polar '(0.0 0.0) A1 (nth 2 vb)) A2 (nth 2 vv)))
     (setq Rs (distance '(0.0 0.0) ps) As (atan (cadr ps) (car ps)))
     (setq vr (list 0 0 Rs As (nth 4 vb) pbs pes))
     ))
   ))
   (setq vr vr)
)
;-------------------------------------------------------------------------
(defun subang (vc ang clb / an cl nvc)
 (setq an (nth 3 vc) cl (nth 4 vc) nvc (abs (nth 1 vc)))

     (cond ((= cl nil)
            (corvec nvc (list nil ang clb)) (setq clb clb))

           ((> cl clb)
            (foreach v vec (reclas v (- ang an) clb cl)) (setq clb clb))

           ((< cl clb)
            (foreach v vec (reclas v (- an ang) cl clb)) (setq clb cl))
     )
)
;-------------------------------------------------------------------------
(defun subrad (vr R nRb)
;      -
  (if (= (abs (nth 1 vr)) nRb) (corvec (nth 0 vr) (list R nil nil)))
)
;-------------------------------------------------------------------------
(defun detect (vv / R A d)
       (setq R (nth 4 vv) A (nth 5 vv))
       (setq d (cond ((and (/= R nil) (/= A nil)) 0)
                     ((and ( = R nil) (/= A nil)) 1)
                     ((and (/= R nil) ( = A nil)) 2)
                     ((and ( = R nil) ( = A nil)) 3)))
)
;-------------------------------------------------------------------------
(defun putpic ( / n)
 (setq npbas 1)

   (setq p1 (assoc npbas pnt))
   (setq pnew (getpoint "New base point:")) (terpri)
   (setq  ang (* (atof (getstring  "Rotation angle <0>: ")) api))

   (setq pnt (subst (cons (- (car p1)) pnew) p1 pnt))

   (setq action t)
   (while (= action t)
          (setq action nil)
      (foreach v vec (defvec v))
   )

   (setq n 1)
   (while (<= n nv)
     (setq v (nth n vec))
     (cond ((= (nth 1 v) 1) (setq n (putlin v n)))
           ((> (nth 1 v) 1) (setq n (putarc v n)))
     )
    (setq n (1+ n))
   )
)
;-------------------------------------------------------------------------
(defun defvec (v / pb pe ppb ppe)
  (if (> (car v) 0) (progn
   (setq pb (nth 2 v) pe (nth 3 v))
   (setq ppb (assoc (- pb) pnt) ppe (assoc (- pe) pnt))
      (cond ((and (/= ppb nil) (= ppe nil))
             (defpnt v ppb pe (nth 4 v) (+ (nth 5 v) ang)))

            ((and (= ppb nil) (/= ppe nil))
              (defpnt v ppe pb (- (nth 4 v)) (+ (nth 5 v) ang)))

            ((and (/= ppb nil) (/= ppe nil))
              (setq vec (subst (cons (- (car v)) (cdr v)) v vec)))
      )
  ))
)
;-------------------------------------------------------------------------
(defun defpnt (vr p np R A)
 (setq pnt (subst (cons (- np) (polar (cdr p) A R)) (assoc np pnt) pnt)
       vec (subst (cons (- (car vr)) (cdr vr)) vr vec)
    action t)
)
;-------------------------------------------------------------------------
(defun putlin (vr n)
  (command "LINE" (cdr (assoc (- (nth 2 vr)) pnt))
                  (cdr (assoc (- (nth 3 vr)) pnt)))
  (command)
  (setq n n)
)
;-------------------------------------------------------------------------
(defun putarc (vr n / vn)
  (if (= n nv) (progn
      (command "CIRCLE" (cdr (assoc (- (nth 2 vr)) pnt)) (nth 4 vr))
      (setq n n))
      (progn
       (setq vn (nth (+ 1 n) vec))
         (if (= (nth 1 vr) (nth 1 vn))
         (progn
             (command "ARC" "C" (cdr (assoc (- (nth 2 vr)) pnt))
                                (cdr (assoc (- (nth 3 vr)) pnt))
                                (cdr (assoc (- (nth 3 vn)) pnt)))
             (setq n (1+ n)))
         (progn
             (command "CIRCLE" (cdr (assoc (- (nth 2 vr)) pnt)) (nth 4 vr))
             (setq n n)
         ))
       ))
)
;-------------------------------------------------------------------------
(defun & (a b / c) (if (= b nil) (setq c a) (setq c b)))
;-------------------------------------------------------------------------
(defun corvec (num new / lst old)
;     
  (setq new (append '(nil nil nil nil) new '(nil nil)))
  (setq old (assoc num vec))
  (setq new (mapcar '& old new))
  (setq vec (subst new old vec))
)
;-------------------------------------------------------------------------
;;------------> IZDELIE <-------------------------------------------------
;;
;;  Adding PG for AutoCAD r15
;;   
;;       
;;   (+ mdll.lsp, *.mdl)
;;  
;;    ..
;;   Copyright  \"SingleSoft PG\" "
;;                       mailto:gepos@mail.ru 
;;
;;------------------------------------------------------------------------
;;------------> MAIN PROGRAMM <-------------------------------------------
(defun izdelie (izd)
 
 (setq osm (getvar "OSMODE"))
 
 (cond ( ;;---------------- no selection
        (= izd 0) (exit) 
       ) ;; 
       ( ;;---------------- flange
        (= izd 1)        
             (progn (command "VSLIDE" "izdelie(flang-r)")
                    (models "flange.mdl")
             )
       ) ;;
       ( ;;---------------- flange prot
        (= izd 2)        
             (progn (command "VSLIDE" "izdelie(flang-1r)")
                    (models "flang-p.mdl")
             )
       ) ;;
       ( ;;---------------- nippel
        (= izd 3)        
             (progn (command "VSLIDE" "izdelie(nippel-r)")
                    (models "nippel.mdl")
             )
       ) ;;
       ( ;;---------------- shtucer
        (= izd 4)        
             (progn (command "VSLIDE" "izdelie(shtuc-r)")
                    (models "shtucer.mdl")
             )
       ) ;; ----- shtucer end
                  
  ) ;;--------- end cond
 (setvar "OSMODE" osm)
) 
;;------------> end <----------------------------------------------------- 