;***********************************************************************
;                            TECTR.lsp                                 *
;                                 & tectr.dcl                          *
;               Copyright by PG (Genchik Pospelov) &  .       *
;                             AutoCAD r.14                          *
;                           03. 1999                              * 
;                   E-Mail: gepos@mail.ru / nest@tomcat.ru             *
;***********************************************************************

;;;---------------------------------------------------------------------
(defun ai_abort (app msg)
     (defun *error* (s)
        (if old_error (setq *error* old_error)) (princ)
     )
 (if msg (alert(strcat " Application error: " app " \n\n " msg "\n"))
  )
 (exit)
)
;;;-------------------------------------------------------------
;;; Check to see if AI_UTILS is loaded, If not, try to find it,
;;; and then try to load it.
;;; If it can't be found or it can't be loaded, then abort the
;;; loading of this file immediately, preserving the (autoload)
;;; stub function.
  (cond
     (  (and ai_dcl (listp ai_dcl)))    ; it's already loaded.

     (  (not (findfile "ai_utils.lsp"))           ; find it
        (ai_abort "tectr"
                  (strcat "Can't locate file AI_UTILS.LSP."
                          "\n Check support directory.")))

     (  (eq "failed" (load "ai_utils" "failed"))   ; load it
        (ai_abort "tectr" "Can't load file AI_UTILS.LSP"))
  )

  (if (not (ai_acadapp))         ; defined in AI_UTILS.LSP
      (ai_abort "tectr" nil)     ; a Nil <msg> supresses
  )                              ; ai_abort's alert box dialog.
;;; ==================== end load-time operations ===================
;;------------------------------------------------------------------------
;;-----------> help about programm <--------------------------------------
;;------------------------------------------------------------------------
(defun hlp_inf (op_wind /)
 (if (not (new_dialog op_wind tectr_dcl)) (exit))
 (action_tile  "accept" "(done_dialog)")
 (start_dialog)
)

;;;---------------------------------------------------------------------
;    .
;S - . L -  .  .
;-----------------------------------------------------------------------
(defun STR_NOM ( S L / N )
 (setq N (1- (length L)))
 (while (and (/= S (nth N L)) (>= N 0))       (setq N (1- N))
 )
 (setq N (rtos N 2 0))
)
;-----------------------------------------------------------------------
;------>       <----------
;-----------------------------------------------------------------------
(defun list_tt ( / FILE S)
 
 (if (not (new_dialog "tt_text" tectr_dcl)) (exit))
 (setq  FILE (open f_tt "r")
       redit 0 
 )
 (start_list "text" )
 (while (setq S (read-line FILE)) (add_list S))
 (end_list)
 (close FILE)

 (set_tile "pg_red" "0")
 (action_tile "pg_red" "(setq redit 1)")
 (action_tile "accept" "(done_dialog)")
 (start_dialog)
)
;-----------------------------------------------------------------------
;------>     <--------------------
;-----------------------------------------------------------------------
(defun make_tt ( / tt_list FILE NTT TT M fil_tt s)

 (setq fil_tt "tectr.dat")

 (setq fil_tt (findfile fil_tt)
      tt_list (list "------------>   <-----------")  
         FILE (open fil_tt "r")
  )
;;---    
 (while
        (setq s (read-line FILE))
  (setq tt_list (cons s tt_list))
 )
 (close FILE)
 
 (setq tt_list (reverse tt_list))
;;---    

;;--- new dialog --------------------
 (if (not (new_dialog "m_tt" tectr_dcl)) (exit))
 (start_list "tt_list" 3)
 (mapcar 'add_list tt_list)
 (end_list)
 (action_tile "tt_list" "(setq TT $value)")
 (action_tile "help"  "(hlp_inf \"hlp_text\")")
 (action_tile "info"  "(hlp_inf \"inf_text\")")
 (action_tile "accept"  "(done_dialog 1)")
 (action_tile "cancel"  "(done_dialog 0)")
 (if (= (start_dialog) 0) (exit))

 (if (setq M TT)
  (progn            ;------>   
   (setq FILE (open (strcat (getvar "DWGNAME") ".tt") "w"))
   (setq NTT 1)
   (setq TT (STR_LIST TT))
   (while TT
    (if (/= (substr (nth (car TT) TT_LIST) 1 1) " ")
     (progn
      (write-line (strcat (rtos NTT 2 0) ". " (nth (car TT) TT_LIST)) FILE)
      (setq NTT (1+ NTT))
     )
      (write-line (substr (nth (car TT) TT_LIST) 2) FILE)
    )
    (setq TT (cdr TT))
   )
   (close FILE)
  )
 ) -----> close IF YES
 (setq f_tt (if M (strcat (getvar "DWGNAME") ".TT") nil)) ;-->
)
;-------------------------------------------------------------------------
;------------>   <------------------------------------------
;-------------------------------------------------------------------------
(defun STR_LIST (S / I L)
 (while (> (strlen S) 0)
  (setq I 1)
  (while (and (/= " " (substr S I 1)) (/= "" (substr S I 1)))
   (setq I (1+ I))
  )
  (setq L (cons (atoi (substr S 1 (1- I))) L))
  (setq S (substr S (1+ I)))
 )
 (setq L (reverse L))
)
;-----------------------------------------------------------------------
;;; ************************************************************
;;; ---------->    <------------------------
;;; ************************************************************

(defun main_tt ( / ht  htt  nstt)
 
;  
;-----------------------------------------------------------------------
 (setq tectr_dcl (load_dialog "tectr.dcl"))

  ;  
 (make_tt)
  ;  
 (list_tt)
  ; 1-yes
 (if (= redit 1) (COMMAND "NOTEPAD" f_tt))

 (unload_dialog tectr_dcl)


;    
;-----------------------------------------------------------------------
  (if (findfile (strcat (getvar "DWGNAME") ".tt"))
   (progn
   (setq FILE (open (strcat (getvar "DWGNAME") ".tt") "r"))
      (setq p1 (getpoint "\n    :"))
      (while (setq S (read-line FILE))
       (if p1 (progn
                (command "TEXT" p1 3.5 0 S)
                (setq p1 nil)
               )
          (command "text" "" S)
       )
      );end while
   (close FILE)
   )
  (princ "\n   .")
  )
)
;;;*************************************************************************
;;;-------------- >   <------------------------------------
;;;*************************************************************************

(defun C:tectr ( / olderr file old_snap
                               old_layer
                               old_color)
 
 (setq olderr  *error*             ; Initialize variables
       *error* prerr
      old_snap  (getvar "osmode")
 )    
 (setvar "osmode"   0)
 (setvar "blipmode" 0)
 (setvar "cmdecho"  0)
 
 ;; Set up error function.
  (setq   old_cmd (getvar "cmdecho")    ; save current setting of cmdecho
       old_error  *error*               ; save current error function
          *error* ai_error              ; new error function
  )

;   
  (main_tt)
 (unload_dialog tectr_dcl) 
 (setvar "blipmode" 1)
 (setvar "cmdecho" 1)
 (setvar "osmode" old_snap)
 (setq *error* olderr)             ; Rest ore old *error* handler
(princ)
)
;;;***********************> THE END <***************************************
