;;-----------> TRATEXT.LSP <---------------------------------------------
;;;      TRANSITion.DWG    TRANSIT.DCL
;;         
;;------------------------------------------------------------------------
;;  Adding PG for AutoCAD r14 12/08/97
;; 20/08/99  AutoCAD r15 (2000)
;; 
;;
;;   Copyright  \"SingleSoft PG\" "
;;                       mailto:gepos@mail.ru 
;;
;;------------------------------------------------------------------------
;;;
;;; ===================== load-time error checking ======================
  (defun ai_abort (app msg)
    ;(defun *error* (s)
    ;    (if old_error (setq *error* old_error))
    ;    (princ)
    ; )
     (if msg
       (alert (strcat " Application error: "
                      app
                      " \n\n  "
                      msg
                      "  \n"
  )       )     )     (exit)
  )
  (cond
     (  (and ai_dcl (listp ai_dcl)))          ; it's already loaded.

     (  (not (findfile "ai_utils.lsp"))                     ; find it
        (ai_abort "transit"
                  (strcat "Can't locate file AI_UTILS.LSP."
                          "\n Check support directory.")))
     (  (eq "failed" (load "ai_utils" "failed"))            ; load it
        (ai_abort "transit" "Can't load file AI_UTILS.LSP"))
  )
  (if (not (ai_acadapp))               ; defined in AI_UTILS.LSP
      (ai_abort "transit" nil)         ; a Nil <msg> supresses
  )                                    ; ai_abort's alert box dialog.
; ==================== end load-time operations ====================
;_____________________________________________________________________
(defun calcl ( a b d h f / s1 s2 rez)
 (setq
      s1 (-(/ a 2) (/(* d (sin f)) 2))
      s1 (abs s1)
      s1 (* s1 s1)
      s2 (-(/ b 2) (/(* d (cos f)) 2))
      s2 (abs s2)
      s2 (* s2 s2)
      h (* h h)
      rez (sqrt (+ s1 s2 h ))
  )
)
;;-----------> transition <--------------------------------------------------
;  The main dialogue.
;------------------------------------------------------------------------
(defun c:transit( /  $value           pg_ak        pg_bk        pg_d0    
                     pg_hl            pg_tl        reset        what_next
                     old_cmd          do_trans     dtrans_main  dcl_id
                     on_screen_tog    check_input  on_screen    on_screen  
                     bad_par
                )

;------------------------------------------------------------------------
(defun do_trans( / fi r kk ln pt0)
 (setq fi (list 0.00001  0.5236  1.0472  1.5708)
       pg_ak (+ pg_ak pg_tl)  ;  ,
       pg_bk (+ pg_bk pg_tl)
       pg_d0 (+ pg_d0 pg_tl)
       kk (min pg_ak pg_bk)
       ln '()
       pg_bk (max pg_ak pg_bk)
       pg_ak kk
       kk 0
       r (/(* pg_d0 3.1416) 12)
    )
 (setq ln (list (rtos(sqrt (+(* pg_hl pg_hl)
                         (/ (*(- pg_bk pg_d0)(- pg_bk pg_d0)) 4))
                  ) 2 1)
                 (rtos(calcl pg_ak pg_bk pg_d0 pg_hl (nth 0 fi))2 1)
                 (rtos(calcl pg_ak pg_bk pg_d0 pg_hl (nth 1 fi))2 1)
                 (rtos(calcl pg_ak pg_bk pg_d0 pg_hl (nth 2 fi))2 1)
                 (rtos(calcl pg_ak pg_bk pg_d0 pg_hl (nth 3 fi))2 1)
                 (rtos(sqrt (+(* pg_hl pg_hl)
                         (/ (*(- pg_ak pg_d0)(- pg_ak pg_d0)) 4))
                  ) 2 1)
                 (rtos r  2 1)
                 (rtos pg_ak 2 2)
                 (rtos pg_bk 2 2)
                 (rtos pg_d0 2 2)
             )
    )
 (setq pt0 (getpoint "\n    : ")
       pg_tl (rtos pg_tl 2 1)
  )
 (command "INSERT" "TRANSITION" pt0 1.0 1.0 0.0)
 (setq pt0 (list (+ (car pt0)57.0)(+ (cadr pt0)18.0))
       pg_tl (strcat pg_tl "*")
  )
 ;(command "DTEXT" pt0 4 0 pg_tl)
(print pg_tl)
(print pt0)
(command "TEXT" pt0 4 0 pg_tl)
 (setq pt0 (list (+(car pt0)120)(+(cadr pt0) 236))
       kk 0)
 (repeat (length ln)
        (command "TEXT" pt0 4 0 (nth kk ln))
        (setq kk (1+ kk)
              pt0 (list (+(car pt0) 24) (cadr pt0))
            )
   )
 (command "ZOOM" "ALL")
 (terpri)
 (princ "That's All - ")
 ) 
;-----------------  END FUNCTION    do_trans ------------------
;------------------------------------------------------------------
 (defun reset()
   (set_tile "error" " ")
 )

; Check some input and set focus on error.  Return nil is nothing bad.
;---------------------------------------------------------------------
  (defun bad_par()
    (cond 
      ((not (setq pg_ak (ai_num (get_tile "pg_ak") "Invalid A dim." 0)))
        (mode_tile "pg_ak" 2)
      )
      ((not (setq pg_bk (ai_num (get_tile "pg_bk") "Invalid B dim." 0)))
        (mode_tile "pg_bk" 2)
      )
      ((not (setq pg_d0 (ai_num (get_tile "pg_d0") "Invalid Do dim." 0)))
        (mode_tile "pg_d0" 2)
      )
      ((not (setq pg_hl (ai_num (get_tile "pg_hl") "Invalid H dim." 0)))
        (mode_tile "pg_hl" 2)
       )
      ((not (setq pg_tl (ai_num (get_tile "pg_tl") "Invalid T dim." 0)))
        (mode_tile "pg_tl" 2)
      )
      (t (done_dialog 1))
    )
  )
; Enable/Disable for Insertion Point.
;;;----------------------------------------------------------------------
  (defun on_screen_tog()
        (mode_tile "pg_ak" 0)
        (mode_tile "pg_bk" 0)
        (mode_tile "pg_d0" 0)
        (mode_tile "pg_hl" 0)
        (mode_tile "pg_tl" 0)
  )
 
; Put up the dialogue.
;-------------------------------------------------------------------------
  (defun _dtrans_main()

   (if (not (new_dialog "transit" dcl_id)) (exit))

    ;; Set up some defaults.
    (setq pg_ak 0.0)           (set_tile "pg_ak" (rtos pg_ak))             
    (setq pg_bk 0.0)           (set_tile "pg_bk" (rtos pg_bk))             
    (setq pg_d0 0.0)           (set_tile "pg_d0" (rtos pg_d0))             
    (setq pg_hl 200.0)         (set_tile "pg_hl" (rtos pg_hl))          
    (setq pg_tl 2.0)           (set_tile "pg_tl" (rtos pg_tl))          

   (if (setq on_screen (cadr (assoc "transit" ai_defaults)))
     (set_tile "on_screen" (itoa on_screen))
      (set_tile "on_screen" (itoa (setq on_screen 1)))
   )
    
   (on_screen_tog)
   (action_tile "pg_ak" "(reset)(ai_num $value \"Invalid A dim.\" 0)")
   (action_tile "pg_bk" "(reset)(ai_num $value \"Invalid B dim.\" 0)")
   (action_tile "pg_d0" "(reset)(ai_num $value \"Invalid D dim.\" 0)")
   (action_tile "pg_hl" "(reset)(ai_num $value \"Invalid H dim.\" 0)")
   (action_tile "pg_tl" "(reset)(ai_num $value \"Invalid T dim.\" 0)")
   
   (action_tile "accept" "(bad_par)")
   (action_tile "cancel" "(done_dialog 0)")
   (action_tile "help" "(done_dialog 0)")
   
   (setq what_next (start_dialog))

    (if (= 1 what_next) 
      (progn
        (do_trans)
        (if (assoc "transit" ai_defaults)
         (setq ai_defaults (subst (list "transit" on_screen) 
                                   (assoc "transit" ai_defaults)
                                   ai_defaults
                            )
         )
         (setq ai_defaults (cons (list "transit" on_screen) ai_defaults))
        )
      )
    )  ; CLOSE- (if (= 1 what_next) 
  )    ; CLOSE- defun _dtrans_main()

;---------------------------------------------------------------
  ;; Set up error function.
  (setq old_cmd (getvar "cmdecho")    ; save current setting of cmdecho
        old_error  *error*            ; save current error function
        *error* ai_error              ; new error function
  )
  (setvar "cmdecho" 0)

  (cond
     (  (not (ai_notrans)))                     ; transparent not OK
     (  (not (ai_acadapp)))                     ; ACADAPP.EXP xloaded?
     (  (not (setq dcl_id (ai_dcl "transit")))) ; is .DCL file loaded?

     (t (_dtrans_main))                         ; proceed!
  )

  (setq *error* old_error) 
  (setvar "cmdecho" old_cmd)
  (princ)
)
;;;----------------------------------------------------------------------
(terpri)
(princ)
;;------------> END  TRANSITION.LSP <-------------------------------------
